2004-03-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (ReconfigureWindowsMenu):
	Back port child menu id fix from Tk CVS head.

2004-01-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Add DESTDIR support.

2003-12-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (DrawMenuEntryLabel): Fix
	missing variable error created by the last
	checkin on 2003-12-27.

2003-12-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (ReconfigureWindowsMenu,
	TkWinHandleMenuEvent, DrawMenuEntryArrow):
	Fix drawing of a disabled cascade menu
	arrow. Tk was displaying a disabled cascade
	menu arrow in black instead of gray. This
	was caused by a bug in the Win32 code for
	user drawn menu items. The fix is to avoid
	telling Windows that the menu item is a
	cascade type and then draw the gray arrow
	bitmap on our own.
	[Tk Patch 865842]

2003-12-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (DrawMenuEntryAccelerator,
	DrawMenuEntryLabel): When drawing the label
	text and accelerator text for a disabled
	menu entry be sure to draw a 3D highlight.
	The only exception to this is when a
	disabled menu entry is highlighted, in that
	case do not draw a 3D hightlight.

2003-12-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (DrawMenuEntryAccelerator,
	DrawMenuEntryArrow): Move the unused menu
	arrow drawing code in DrawMenuEntryAccelerator
	into a new function named DrawMenuEntryArrow.
	This makes no functional change but it will
	make it easier to fix things in the future.

2003-12-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (DrawWindowsSystemBitmap):
	Fix a strange Win32 bug where the logical
	coordinates returned by a call to DPtoLP
	are wrong the first time a menu is posted.
	This bug manifested itself by drawing the
	bitmap in the wrong place in a menu.
	The fix was to pass the newly created DC
	instead of the DC from the window.
	[SN Bug 814335]

2003-12-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinMenu.c (TkWinHandleMenuEvent,
	RecursivelyClearActiveMenu, TkpSetWindowMenuBar,
	DrawMenuEntryBackground): Back port a couple
	of menu fixes from the Tk CVS. This patch fixes
	a problem with Win32 menus where a menu entry
	that is disabled was not being highlighted
	when the mouse is over the item. This matches
	the native Win32 behavior.

2003-12-25  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure:
	* win/tcl.m4 (SC_ENABLE_SYMBOLS): Fix last
	update to macro, the Win32 DBGX symbol should
	be d not g.

2003-11-29  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4 (SC_ENABLE_SYMBOLS):
	* win/configure: Regen.
	* win/tcl.m4 (SC_ENABLE_SYMBOLS): Update
	macro to support passing --enable-symbols=mem
	on the configure command line.

2003-09-13  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4 (SC_PATH_X): Error out in the
	configure if no X11 includes can be found.

2003-08-10  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Remove evil rerun of autoconf.
	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl to get CFLAGS
	opt fix.
	* win/configure: Regen.
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Update macro
	to behave more like the Tcl version of same.

2003-08-10  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinWm.c: Back port of wm iconbitmap
	feature from Tk 8.4. This feature provides the
	ability to set a Windows icon for toplevel
	windows.

2003-04-07  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkBind.c (TkpGetBindingXEvent): Add helper method
	that can be used to query the XEvent* for the currently
	executing binding.
	* generic/tkInt.h: Declare TkpGetBindingXEvent.
	* win/tkWinMenu.c (MenuKeyBindProc, TkWinMenuKeyObjCmd,
	TkpInitializeMenuBindings): Rename MenuKeyBindProc to
	TkWinMenuKeyObjCmd and convert it into a Tcl command
	named tk_tkWinMenuKey. Bind keyboard accelerator
	actions to this Tcl command instead of using a native
	C binding so that user code can manipulate the binding
	in Tcl code.
	[Source-Navigator bug 570080]

2003-03-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkImgPhoto.c (ImgPhotoCmd):
	* generic/tkMenu.c (MenuWidgetObjCmd): Remove
	unused local variables which made the compile
	fail under VC++ when --enable-symbols is passed.

2003-02-17  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinPort.h: Define ALWAYS_SHOW_SELECTION
	so that the selected highlight is shown when
	multiple windows can display a selection.

2003-02-17  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkEvent.c (Tk_HandleEvent): Fixup button
	press state saving code, it was incorrectly converting
	normal motion events into button press and motion
	events in some cases.
	* generic/tkInt.h: Add mouseButtonWindow member
	to the TkDisplay structure.
	* tests/event.test: Add test case for faulty
	button motion logic.

2003-02-15  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in:
	* win/Makefile.in: Add TCL_DBGX so that the
	build works with --enable-symbols.

2003-02-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure: Regen.
	* win/configure.in: Set CC and CFLAGS when
	compiling with VC++. Call AC_CANONICAL_HOST.

2003-02-11  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure: Regen.
	* win/configure.in: Set the c preprocessor and
	executable extensions to work around problems
	that autoconf 2.13 has with VC++.

2002-09-13  Keith Seitz  <keiths@redhat.com>

	From Mo Dejong  <supermo@bayarea.net>:
	* win/tkWinWm.c (Tk_WmCmd): Check the WM_NEVER_MAPPED
	flag while processing the wm deiconify command.
	The WM_UPDATE_PENDING flag should never be set when
	WM_NEVER_MAPPED is set, but double check so that
	the implementation is more explicit and matches
	the comment just above.
	Return without invoking TkWmRestackToplevel or
	TkSetFocusWin on a toplevel that has never been
	mapped. This fixes a bug where a toplevel is mapped
	with the wrong size and is then resized by the
	idle call to MapFrame.

2002-07-31  Keith Seitz  <keiths@redhat.com>

	* win/winMain.c (main): Ifdef out for cygwin.

	* win/tcl.m4 (SC_CONFIG_CFLAGS): Add TK_DLL_BASE variable
	to define DLL image bases on cygwin.
	Do not link with "-e _WinMain@16" on cygwin.
	* win/configure.in (TK_DLL_BASE): Substitute into makefile.
	* win/configure: Regenerated.
	* win/Makefile.in: Use TK_DLL_BASE to build DLLs.

2002-07-31  Keith Seitz  <keiths@redhat.com>

	From Mo DeJong  <supermo@bayarea.net>
	* generic/tkText.c (ExecSyncCmd):
	Remove -synccommand option from Tk text widget.
	This local modification was used by an very old
	version of Source-Navigator, but is no longer
	needed. Remove ExecSyncCmd function.
	* generic/tkText.h (TkText): Remove SyncCmd member.
	* library/msgbox.tcl (tkMessageBox): Remove unused
	-modal option. This was a local mod to tk.
	* tests/text.test: Add default value for -tabsize.
	This is a local mod to tk.
	* tests/wm.test: Fixup iconwindow error messages.

2002-01-24  DJ Delorie  <dj@redhat.com>

	* xlib/X11/Xutil.h (XEmptyRegion): Returns Bool.

2001-10-28  Christopher Faylor  <cgf@redhat.com>

	* win/configure.in: Modify 2001-10-10 change to check for cygwin host
	rather than cygwin target.
	* win/configure: Regenerate.

2001-10-15  Ian Roxborough  <irox@redhat.com>

	* win/tkWinButton.c (TkpComputeButtonGeometry):
        Windows look and feel fix modified to leave
        labels alone.

Wed Oct 10 21:06:11 2001  Christopher Faylor <cgf@cygnus.com>

	* win/configure.in: Add detection for -mwin32 option requirement under
	cygwin.
	* win/configure: Regenerate.

2001-09-12  Ian Roxborough  <irox@redhat.com>

	* configure: Regenerated.
	* win/configure: Regenerated.
	* win/configure.in: Set XINCLUDES using absolute path
	rather than relative path.
	* win/tkWinDialog.c (ChooseDirectoryHookProc): Use
	__TEXT instead of _T (this might be bad practice).
	
2001-08-08  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4: Update from Tcl.
	* unix/configure: Regen.
	* win/configure: Regen.

2001-08-06  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4: Update from Tcl.
	* unix/configure: Regen.
	* win/configure: Regen.

2001-08-06  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Remove TCL_LIB_FLAG, replace TCL_LIB_SPEC
	with TCL_BUILD_LIB_SPEC.	
	* unix/configure: Regen.
	* unix/configure.in: Avoid resetting TCL_LIB_SPEC and
	TCL_STUB_LIB_SPEC since they are already set in tclConfig.sh. Subst
	TCL_BUILD_STUB_LIB_SPEC and TCL_BUILD_LIB_SPEC into the Makefile.
	* win/Makefile.in: Use TCL_LIB_SPEC and TCL_STUB_LIB_SPEC from
	tclConfig.sh instead of creating them via a cygpath call. Use
	TCL_STUB_LIB_SPEC in place of TCL_STUB_LIB_FILE.
	* win/configure: Regen.
	* win/configure.in: Fixup TK_STUB_LIB_SPEC, TK_BUILD_STUB_LIB_PATH,
	TK_STUB_LIB_PATH, TK_LIB_FLAG, TK_BUILD_LIB_SPEC, TK_LIB_SPEC
	and TK_LIB_FULL_PATH variables so they work like the unix version.

2001-08-01  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4: Update from Tcl.
	* unix/configure: Regen.
	* unix/configure.in: Use TCL_TOOL_SHARED_LIB_LONGNAME
	and TCL_TOOL_STATIC_LIB_LONGNAME to generate lib names.
	* win/configure: Regen.
	* win/configure.in: Use TCL_TOOL_SHARED_LIB_LONGNAME
	and TCL_TOOL_STATIC_LIB_LONGNAME to generate lib names.

2001-07-24  Mo DeJong  <mdejong@redhat.com>

	* generic/default.h: Include tkWinDefault.h
	when built with Cygwin or Mingw.

2001-07-24  Mo DeJong  <mdejong@redhat.com>

	* win/configure:
	* win/tcl.m4: Update from Tcl.

2001-07-12  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in:
	* unix/configure: Regen.
	* unix/configure.in:
	* unix/tcl.m4:
	* win/Makefile.in:
	* win/configure: Regen.
	* win/configure.in:
	* win/tcl.m4:
	Revert ill-conceived EXTRA_CFLAGS changes made on 2001-07-09.
	The change ended up causing big problems with the
	tclConfig.sh file since	it exported EXTRA_CFLAGS and did
	not deal with the debug/non-debug case.

2001-07-11  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2001-07-11  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Add AR and STLIB_LD variables.
	* unix/configure: Regen.
	* unix/configure.in: Use STLIB_LD when defining MAKE_LIB
	and MAKE_STUB_LIB. Subst STLIB_LD, RANLIB, and AR.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-07-10  Mo DeJong  <mdejong@redhat.com>

	* win/configure:
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Use STLIB_LD in MAKE_LIB instead
	of AR which can be overridden on the make command line.

2001-07-09  Mo DeJong  <mdejong@redhat.com>

	* win/configure:
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Fix quoting of CYGPATH
	argument to AC_CHECK_PROG.

2001-07-09  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Add EXTRA_CFLAGS_DEBUG and EXTRA_CFLAGS_OPTIMIZE
	variables. These two do not actually differ in the unix version
	but are there to keep in sync with the Windows version.
	* unix/configure: Regen.
	* unix/configure.in: Don't subst EXTRA_CFLAGS. Subst EXTRA_CFLAGS_DEFAULT,
	EXTRA_CFLAGS_DEBUG, and EXTRA_CFLAGS_OPTIMIZE.
	* unix/tcl.m4: Update from Tcl.
	* win/Makefile.in: Add EXTRA_CFLAGS_DEBUG and EXTRA_CFLAGS_OPTIMIZE
	variables. This is needed so that the proper runtime lib gets linked
	into VC++ produced .obj files when CFLAGS is reset on the command line.
	* win/configure: Regen.
	* win/configure.in: Don't subst EXTRA_CFLAGS. Subst EXTRA_CFLAGS_DEFAULT,
	EXTRA_CFLAGS_DEBUG, and EXTRA_CFLAGS_OPTIMIZE.
	* win/tcl.m4: Update from Tcl.

2001-07-06  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-07-06  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/configure.in: Replace call to SC_ENABLE_GCC with
	AC_PROG_CC so that CC passed in from the caller is respected.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/configure.in: Replace call to SC_ENABLE_GCC with
	AC_PROG_CC so that CC passed in from the caller is respected.
	* win/tcl.m4: Update from Tcl.

2001-07-06  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in: Subst DEPARG directly instead
        of relying on a variable. This will make Cygwin
        builds faster since an extra exec will be avoided.
	* win/configure: Regen.
	* win/configure.in: Subst DEPARG.
	* win/tcl.m4: Update from Tcl.

2001-06-26  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4: Update from Tcl.
	* unix/configure: Regen.
	* win/Makefile.in: Remove PATHTYPE variable.
	Use : in VPATH instead of VPSEP.
	* win/configure: Regen.
	* win/configure.in: Don't subst PATHTYPE or VPSEP.
	* win/tcl.m4: Update from Tcl.

2001-06-25  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Set CFLAGS to @CFLAGS@ and @CFLAGS_DEFAULT@.
	Set LDFLAGS to @LDFLAGS@ and @LDFLAGS_DEFAULT@. Add LDFLAGS_DEBUG
	and LDFLAGS_OPTIMIZE to match the way CFLAGS_DEFAULT works. Use
	new LDFLAGS variable in the Makefile instead of @LDFLAGS@.
	* unix/configure: Regen.
	* unix/configure.in: Don't set CFLAGS to CFLAGS_DEFAULT, instead
	subst CFLAGS_DEFAULT into the Makefile. Add AC_SUBST for CFLAGS_DEBUG,
	CFLAGS_OPTIMIZE, LDFLAGS_DEFAULT, LDFLAGS_DEBUG, and LDFLAGS_OPTIMIZE.
	Remove unused LD_FLAGS subst.
	* unix/tcl.m4: Update from Tcl.
	* win/Makefile.in: Set CFLAGS to @CFLAGS@ and @CFLAGS_DEFAULT@.
	Set LDFLAGS to @LDFLAGS@ and @LDFLAGS_DEFAULT@.
	* win/configure: Regen.
	* win/configure.in: Don't set CFLAGS or LDFLAGS, instead subst
	CFLAGS_DEFAULT and LDFLAGS_DEFAULT into the Makefile.
	* win/tcl.m4: Update from Tcl.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* configure:
	* configure.in: When a windows32 host is detected
	configure in the win subdirectory.
	* cygtcl.m4: Update from Tcl.
	* unix/configure: Regen.
	* win/configure: Regen.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* win/configure:
	* win/tcl.m4: Update from Tcl.

2001-06-08  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in: Set TK_LIBRARY to
	$INSTALL/share/tk8.3 instead of
	$INSTALL/lib/tk8.3.

2001-06-06  Mo DeJong  <mdejong@redhat.com>

	* win/configure:
	* win/configure.in: Handle the --prefix option correctly
	it should default to /usr/local like the unix version.

2001-06-05  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4:
	* unix/configure: Update from Tcl.

2001-06-01  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4:
	* unix/configure:
	* win/configure:
	* win/tcl.m4: Update from Tcl.

2001-05-30  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/tcl.m4:
	Update from Tcl version.

2001-05-30  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4:
	* unix/configure: Regen.
	* unix/tcl.m4:
	Update from Tcl versions.

2001-05-26  Mo DeJong  <mdejong@redhat.com>

	* cygtcl.m4:
	* unix/aclocal.m4:
	* unix/configure: Regen.
	* unix/tcl.m4:
	* win/aclocal.m4:
	* win/configure: Regen.
	* win/tcl.m4:
	Update from Tcl versions.

2001-05-09  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Use TK_STUB_LIB_FILE instead
	of STUB_LIB_FILE subst.
	* unix/configure: Regen.
	* unix/configure.in: Use new path macros.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/configure.in: Use new path macros.
	* win/tcl.m4: Update from Tcl.

2001-05-08  Ian Roxborough  <irox@redhat.com>

	* unix/configure.in: Cygnus local change
	to build gdbtk: Set TK_BUILD_INCLUDES to
	correct path.
	* unix/configure: Regenerated.
	
2001-04-09  Mo DeJong  <mdejong@redhat.com>

	* unix/aclocal.m4: Pull in tcl.m4.
	* unix/configure: Regen.
	* unix/tcl.m4: Add from tcl/unix.
	* win/Makefile.in: Append version to tclsh
	in the win subdirectory.
	* win/configure: Regen.
	* win/configure.in: The TK_BUILD_LIB_SPEC and
	TK_BUILD_LIB_SPEC variables need to use the
	lib file and not the dll file, since it is
	not possible to link to a dll with VC++.
	Use new TCL_TOOL_PATH macro to correctly
	set the XINCLUDES variable.
	* win/tcl.m4: Update from tcl/win so we can use
	the TCL_TOOL_PATH macro.

2001-04-05  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in: Don't depend on
	TCLSH_PROG variable from configure.
	*  win/configure: Regen.
	* win/configure.in: Don't call
	SC_PROG_TCLSH, it was removed from
	Tcl. This macro required that Tcl
	be built before Tk could be configured.
	* win/tcl.m4: Update from Tcl version.

2000-12-08  Syd Polk  <spolk@redhat.com>

	* unix/configure.in: Change hppa*w to hppa*64.
	* unix/configure: Regenerate.

2000-08-08  Jeff Hobbs  <hobbs@ajubasolutions.com>

	8.3.2 RELEASE finalized

	* changes: updated for release notes version of ChangeLog

2000-08-05  Jeff Hobbs  <hobbs@ajubasolutions.com>

	* win/Makefile.in (cat32.${OBJEXT}): corrected where to find cat.c
	given the change in default def'n of TCL_SRC_DIR.

	* win/tcl.m4: changed references from 8.4 to 8.3 (leftover from a
	backported file).

	* library/safetk.tcl: rationalized the setting of tk_library when
	initialized Tk in a safe interpreter.

2000-08-04  Jeff Hobbs  <hobbs@ajubasolutions.com>

	* BACKPORTED FROM 8.4 (HEAD) BRANCH:

	* tests/button.test:
	* generic/tkButton.c: Added -activeforeground, -activebackground
	for labels, for the -state option.

	* doc/label.n: Added -disabledforeground to list of options [Bug:
	6053].

	* tests/focus.test (focusSetupAlt): removed wm withdraw from proc
	as it would cause a hang for tkwait visibility

	* tests/menu.test:
	* generic/tk3d.c:
	* generic/tkColor.c:
	* generic/tkCursor.c: corrected handling of 3DBorder, Cursor and
	Color objects on multiple screens. [Bug: 5454]

	* generic/tkCursor.c: Added initialization for nextPtr field of
	TkCursor, patch from Nijtmans/Howlett.

	* canvas.test: added test for 5783.
	* generic/tkCanvPoly.c (DisplayPolygon): added checks for the
	polygon fillGC not being empty to prevent segfault. [Bug: 5783]

	* generic/tkImgGIF.c: Applied patch from Jan Nijtmans to fix a
	problem with the GIF writing code [Bug:	5823].
	* generic/tkImgGIF.c: Changed defines for GIF87a/GIF89a to be
	static char arrays with integer initialization, to address EBCIDIC
	vs. ASCII encoding issues and to handle compilers that don't deal
	with "\xAB" syntax for specifying hex values in strings.

	* generic/tkMenu.c (DeleteMenuCloneEntries): Applied fix from
	[Bug: 5275], which corrected a segfault-causing indexing problem
	when deleting entries from torn-off menus.

	* generic/tkPlace.c (Tk_PlaceCmd): reworked place master/slave
	table init'n to prevent seg fault when using place on multiple
	displays.

	* tests/text.test: Added tests for -regexp -nocase searches with
	backslash character classes.
	* tests/text.test: Added tests for searching when text is elided.
	* generic/tkText.c (TextSearchCmd): Text search did not work
	properly when -regexp and -nocase were used, in combination with
	backslash character classes represented by capital letters (ie,
	\W, \M); altered implementation of -regexp -nocase searches to use
	new regexp interfaces to fix this problem.  [Bug: 5988].
	* generic/tkText.c (TextSearchCmd): Text search was not returning
	the correct index when the search covered (but did not search)
	elided characters; corrected this by adjusting the match index by
	the number of elided characters preceeding the start of the match,
	just as is done with embedded windows, etc. [Bug: 5470].
	* generic/tkText.c (TextSearchCmd): Added a test for a NULL
	segment pointer when doing backwards searches for "" on an empty
	text widget. [Bug: 6007].

	* library/focus.tcl: fixed calling of takeFocus proc [Bug: 5372]

	* win/tkWinMenu.c (ReconfigureWindowsMenu): Added MF_GRAYED bit
	for disabled menu entries, to ensure that those which are drawn by
	the system are shown grayed (such as entries on menubars) [Bug: 4372].
	* win/tkWinMenu.c (ReconfigureWindowsMenu): Added code to add the
	MF_SEPARATOR bit for SEPARATOR_ENTRY menu items.  This causes
	separator entries on the system menu to be drawn correctly [Bug: 5451].
	* win/tkWinMenu.c (GetMenuSeparatorGeometry): Tweaked height
	requested for separator bars to be (linespace - (2*descent))
	instead of just (linespace); this makes the separator occupy a
	more correct amount of vertical space. [Bug: 5303].

2000-07-20  Brent Welch <welch@ajubasolutions.com>

	* win/tkConfig.sh.in:
	Made corresponding changes to match gcc for windows mods
	to the rest of the files.

2000-07-28  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in:
	* win/aclocal.m4:
	* win/configure.in:
	* win/tcl.m4: Back port of gcc for windows
	build system from 8.4.

2000-07-26  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/configure.in (TK_PATCH_LEVEL): updated to 8.3.2
	* unix/tk.spec:
	* win/configure.in: 
	* generic/tk.h:
	* README:

2000-07-22  Brent Welch <welch@ajubasolutions.com>
	* win/Makefile.in, win/configure.in, win/rc/tk.rc, win/rc/tk_base.rc
	Trying to generalize .rc files so they work with both DLL's and
	static shell builds.

2000-07-10  Brent Welch <welch@ajubasolutions.com>

	* win/{Makefile.in,configure.in,tkConfig.sh.in}: 
	Cleanup of defines in tkConfig.sh

Tue Jun  6 22:09:02 2000  Christopher Faylor <cgf@cygnus.com>

	* win/Makefile.in: Set up and use autoconf variables throughout to
	allow overriding variables from the make command line.

2000-05-15  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c: changed wm deiconify from using idle
	callback to calling restack and focus code immediately.

2000-04-26  Jeff Hobbs  <hobbs@scriptics.com>

	8.3.1 RELEASE

	* README:
	* mac/README:
	* unix/README:
	* unix/tk.spec:
	* win/README: Updating URLs to reference dev.scriptics.com

2000-04-25  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/Makefile.in:
	* win/Makefile.in: makefile cleanup

2000-04-25  Eric Melski  <ericm@scriptics.com>

	* generic/tkMain.c: Fixed function header comment for Tk_MainEx.

	* unix/mkLinks: 
	* doc/GetScroll.3: Added information about Tk_GetScrollInfoObj
	[Bug: 1866].

2000-04-24  Eric Melski  <ericm@scriptics.com>

	* unix/mkLinks: 
	* doc/Grab.3: Man page for Tk_Grab and Tk_Ungrab [Bug: 1868, 1889]

	* unix/mkLinks: 
	* doc/MainWin.3: Added entry for Tk_GetNumMainWindows [Bug: 1865].

	* unix/mkLinks: 
	* doc/GetHINSTANCE.3: Man page for Tk_GetHINSTANCE [Bug: 1862].

2000-04-24  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkImage.c (Tk_PostscriptImage): added check to create
	necessary prolog for photos
	* generic/tkCanvPs.c: added Tk_PostscriptPhoto that outputs PS for
	photo images
	* generic/tkImgPhoto.c: new func ImgPhotoPostscript and added that
	in as ps proc in tkPhotoImageType.
	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tk.decls: added Tk_PostscriptPhoto

	* generic/tkConfig.c (DoObjConfig): removed direct setting of
	interp->result.

	* mac/tkMacWm.c (Tk_WmCmd): initialized gotToplevel in
	colormapwindows case (bug found by Reasoning, Inc's automated code
	testing).

2000-04-24  Eric Melski  <ericm@scriptics.com>

	* unix/mkLinks: 
	* doc/GetHWND.3: Man page for Tk_GetHWND [Bug: 1863].

	* unix/mkLinks: 
	* doc/HWNDToWindow.3: Man page for Tk_HWNDToWindow [Bug: 1869].

	* unix/mkLinks: 
	* doc/AddOption.3: Man page for Tk_AddOption [Bug: 1854]

2000-04-22  Jim Ingham	<jingham@cygnus.com>

	* mac/tkMacDialog.c (Tk_MacGetOpenFile): Add empty bodies for the 
	"-initialfile" and "-defaultextension" options.

	* mac/tkMacDialog.c (NavServicesGetFile): Only cons the result up
	into a list if multiple is true.

	* mac/tkMacMenus.c (SourceDialog): Use the "tk_getOpenFile"
	instead of hand-coding the dialog with StandardGetFile.  This way
	we get the Navigation dialogs for free.

	* doc/getOpenFile.n: Document the -multiple and -message flags
	which are only implemented on the Mac.  Also note that the -title
	works on the Mac with Nav Services installed.

2000-04-19  Eric Melski  <ericm@scriptics.com>

	* doc/WinViewable.3: 
	* unix/mkLinks: Removed docs for Tk_IsViewable.

	* win/tkWinDialog.c: Removed calls to Tk_IsViewable.

	* generic/tkUtil.c: 
	* generic/tkStubInit.c: 
	* generic/tkDecls.h: 
	* generic/tkCmds.c: 
	* generic/tk.decls: Removed Tk_IsViewable function (it was not
	actually needed).

2000-04-19  Jeff Hobbs  <hobbs@scriptics.com>

	* win/aclocal.m4: made SC_PROG_TCLSH search specifically for
	tclsh*.exe type files to find an executable.

	* win/Makefile.in: fixed up cleanup, winhelp, cat32 targets

	* library/console.tcl: made console use systemfixed font on Win

	* generic/tkEntry.c: removed unnecessary ENTRY_VALIDATE #define

2000-04-19  Eric Melski  <ericm@scriptics.com>

	* generic/tkRectOval.c (ConfigureRectOval): Added checks for valid
	outline settings before creating of outline GC; this means that it
	is really possible now to have an oval or rectangle with no
	outline.  [Bug: 5029].

2000-04-19  Jeff Hobbs  <hobbs@scriptics.com>

	* library/choosedir.tcl (::tk::dialog::file::chooseDir::Config):
	* library/tkfbox.tcl (::tk::dialog::file::Config): removed the
	extraneous glob on -initialdir after file isdir already returned 1
	and moved cd trick into this case as the else already uses [pwd].
	[Bug: 5181]

	* win/winMain.c: moved extern call out of WinMain func

	* README:
	* generic/tk.h:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in: bumped to version 8.3.1

	* library/msgbox.tcl (tkMessageBox): changed to use grid in some
	places, realign icon to anchor nw.

	* mac/tkMacScale.c: reverted tkMacScale.c to 1.5 equivalent (it
	was accidentally bumped forward).

2000-04-18  Eric Melski  <ericm@scriptics.com>

	* win/tkWinPointer.c: Changed Mod2Mask in TkWinGetModifierState to
	ALT_MASK, to fix some event problems [Bugs: 1160, 5088].

	* win/tkWinX.c: Changed Mod2Mask in GetState to ALT_MASK, to fix
	some event problems [Bugs: 1160, 5088].

	* generic/tkInt.h: Moved definition of ALT_MASK and META_MASK here
	so that it would be accessible from other modules than tkBind.c.

	* generic/tkBind.c: Added code in BindEvent to check for ALT_MASK
	and META_MASK in the event state field, as this field may not be
	set up with the correct display modifier mask bits if the XEvent
	structure was created by [event generate] or by the Windows X
	emulation. [Bugs: 1160, 5088].

2000-04-18  Scott Redman  <redman@HILO>

	* win/tk.rc:
	* win/wish.rc:
	* win/wish.ico:  Modified copyright dates in Windows resource
	files.  Updated the icon for wish.exe.

2000-04-17  Eric Melski  <ericm@scriptics.com>

	* win/tkWinDialog.c: Added checks for visibility of parent window
	before creating MessageBox and ChooseColor dialogs; this prevents
	the application from locking when the parent is withdrawn and the
	message box is created.  In these cases, the window will be
	created without a parent.

	* unix/mkLinks: Added WinViewable.3.

	* tests/msgbox.test: Added tests for patch from [Bug: 4997].

	* library/msgbox.tcl: 
	* library/dialog.tcl: Applied patch from [Bug: 4997]; detaches
	dialog window from parent if parent is not viewable.

	* library/bgerror.tcl: Removed workaround from [Bug: 4370]; this
	is superceeded by patches to dialog.tcl.

	* generic/tkCmds.c: Changed WinfoObjCmd to use Tk_IsViewable
	function to determine visibility of windows instead of inlining
	the code.

	* generic/tkStubInit.c: 
	* generic/tkDecls.h: 
	* generic/tk.decls: Added Tk_IsViewable declaration.

2000-04-17  Eric Melski  <ericm@scriptics.com>

	* library/text.tcl: Tweaked double-/triple-click selection;
	previously, anchor and insert marks were placed in unexpected
	locations following a double or triple click.  Now they are placed
	logically.  Also tweaked the extension of selection via
	shift-double-clicks so that it no longer selects the contiguous
	whitespace on the side of the selection opposite the
	double-click. [RFE: 4253].

	* doc/menu.n: Added note regarding rendering of
	checkbuttons/radiobuttons in menubars on different platforms --
	some systems do not draw indicators for check/radiobuttons in
	menubars.

	* library/menu.tcl: Corrected behavior of
	checkbuttons/commands/radiobuttons in menubars [Bug: 630].

	* tests/grid.test: Added test for [grid propagate . 0] to not toggle.
	
	* generic/tkGrid.c: Fixed bogus logic in [grid propagate] that
	caused [grid propagate . 0] to act as a toggle instead of an
	absolute set. [Bug: 2286].

2000-04-16  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinColor.c (FindSystemColor): correct calculation of
	colors when shifting value. [Bug: 4919]

2000-04-16  Jim Ingham   <jingham@cygnus.com>

	* mac/tkMacPort.h: protect against strncasecmp already defined -
	it is in the Pro5 version of MSL.

	* mac/tkMacWindowMgr.c (GenerateKeyEvent): Check for a null tkWin.
	If the hidden window we use for double-buffering controls manages
	to percolate to the top (should never happen, but...) this will
	keep us from crashing.

	* mac/tkMacButton.c (InitSampleControls): Hide the
	double-buffering window BEHIND the first "." window you can find.
	This will keep it from ever being the front window, and thus a
	black hole for events.  * mac/tkMacButton.c (ButtonEventProc):
	Disable the controls when the window is in the background.  This
	is required by the MacOS HIG. This doesn't always get called when
	it should, it still needs more work.

	* mac/tkMacDialog.c: Pretty substantial rewrite to include
	Navigation Services support for systems which have it.

2000-04-14  Eric Melski  <ericm@scriptics.com>

	* win/tkWinKey.c: Added check for ASCII delete character in
	KeycodeToKeysym, to fix [Bug: 5090].  See comment in code for more
	information.

	* generic/ks_names.h: Added Scroll_Lock and Sys_Req definitions.

	* win/tkWinKey.c: Changed implementation of KeycodeToKeysym,
	et. al., to use a keycode table for lookups; this will result in
	faster keycode -> keysym translations for non-ASCII keys like
	Control, Alt, etc.

2000-04-14  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c (WmProc): added check in WM_MOUSEACTIVATE so we
	correctly activate native menus when clicking in when we didn't
	have focus [Bug: 2272]

	* generic/tkCanvas.c (CanvasEventProc:2451): corrected cast

	* generic/tkEntry.c (Tk_EntryObjCmd): adjusted finishing error
	cases and changed TK_CONFIG_NULL_OK to TK_OPTION_NULL_OK

	* tests/scale.test:
	* generic/tkScale.c:
	* generic/tkScale.h:
	* unix/tkUnixScale.c:
	* mac/tkMacScale.c: moved (PixelToValue|ValueToPixel|SetScaleValue)
	to tkScale.c.  Caused an associated variable to be immediately set
	[Bug: 4833]

	* library/scale.tcl (tkScaleActivate): reduced number of scale
	redisplays by checking current value of state before setting it
	again.  [Bug: 4191]

	* tests/winDialog.test: tk_chooseDirectory seems to get a noop
	from GetOpenFileName in the static build, hanging some tests.
	The tests were fixed to timeout (noop cause unknown).

	* unix/aclocal.m4 (SC_ENABLE_THREADS): enhanced the detection of
	pthread_mutex_init [Bug: 4359] and (SC_CONFIG_CFLAGS) added
	--enable-64bit-vis switch for Sparc VIS compilation [Bug: 4995]

2000-04-13  Eric Melski  <ericm@scriptics.com>

	* win/tkWinKey.c: Added smarts to check whether the left or right
	Control, Shift, or Alt key was pressed.  [Bug: 870].

	* win/tkWinMenu.c: Corrected code that created separator items on
	menus; originally, it requested that the system be responsible for
	drawing those items, so it would ignore configuration items like
	the widget background.  Now, we draw the separators ourselves (as
	we do with every other kind of menu item already). [Bug: 1166].

	* win/tkWin3d.c: 
	* unix/tkUnix3d.c: Applied patch from [RFE: 2501]: adds more
	sophisticated smarts to TkpGetShadows, so that the highlight of a
	very bright color is actually distinguishable from the color, and
	the shadow of a very dark color is similarly distinguishable from
	the color.

	* generic/tkCanvas.c: Applied patch from [Bug: 4202]; adds a check
	for NULL tkwin in Tk_CanvasEventuallyRedraw.

2000-04-12  Jeff Hobbs  <hobbs@scriptics.com>

	* test/winClipboard.test:
	* win/tkWinInt.h:
	* win/tkWinClipboard.c (UpdateClipboard):
	* win/tkWinX.c (GenerateXEvent): added updatingClipboard tsd and
	TkWinUpdatingClipboard accessor function to allow us to flag
	ourselves when we are the ones updating the clipboard.  This
	corrected inability to create our own clipboard types within a Tk
	application.  [Bug: 2338 4318]
	* win/tkWinTest.c (TestclipboardCmd): improved TestclipboardCmd
	with better error handling and obj'ification

2000-04-11  Eric Melski  <ericm@scriptics.com>

	* msgcat.n: Added docs for new behavior from patch in [Bug: 4158].

	* msgcat.test: Added tests for new behavior from patch in [Bug:
	4158].
	
	* msgcat.tcl: Applied patch from [Bug: 4158], which enables
	msgcat::mc to search the entire namespace ancestry chain for
	message translations (ie, first it checks the current namespace,
	then the parent, then the parent's parent, etc).  Also allows the
	specification of additional args for msgcat::mc; if extra args are
	given, the [format] command is used to substitute the additional
	args in the translated message.

	* library/bgerror.tcl: Moved check for withdrawn state after check
	for tkerror; this was causing problems when tkerror was used.

2000-04-10  Eric Melski  <ericm@scriptics.com>

	* library/bgerror.tcl: Added check for withdrawn state of . and
	unsetting of transient bit for .bgerrorDialog if . is not
	viewable; this protects against the application hanging on systems
	like Windows, where transient windows are withdrawn with their
	parents. [Bug: 4370].

	* tests/event.test: Added test for [event generate $widget
	<Alt-z>] [Bug: 4611].

	* tests/choosedir.test: Changed "namespace import ::tcltest" to
	"namespace import -force ::tcltest".

	* win/tkWinKey.c: 
	* unix/tkUnixKey.c: 
	* mac/tkMacKeyboard.c: Changed InitKeymapInfo to
	TkpInitKeymapInfo. [Bug: 4611].

	* generic/tkStubInit.c: 
	* generic/tkIntDecls.h: Re-gen'd from tkInt.decls.

	* generic/tkInt.decls: Added TkpInitKeymapInfo to list of function
	decls.

	* generic/tkBind.c (HandleEventGenerate): Added code to initialize
	keymap info if necessary, and to correctly set modifier bits in
	XEvent structure create to handle [event generate] calls.
	Previously, the alt/meta bits were not set correctly, so [event
	generate $widget <Alt-z>] would always fail. [Bug: 4611]

2000-04-07  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkGrid.c (InitMasterData): fixed uninit'd data in
	GridMaster struct [Bug: 4387]

	* library/safetk.tcl (disallowTk): made disallowTk work in the
	simple case.

	* library/comdlg.tcl (tkFocusGroup_In): fixed key navigation
	problems in dialogs under CDE [Bug: 2960]

	* tests/winDialog.test: removed knownBug constraint from 5.16

	* win/tkWinFont.c (GetScreenFont): corrected adjustment against
	LC_FACESIZE limitation for NT [Bug: 4931]

	* win/makefile.vc (TKTEST_OBJS):
	* win/Makefile.in (TKTEST_OBJS): moved tkWinTest.c from normal
	objs to TKTEST_OBJS where it belonged.

2000-04-03  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkTest.c: fixed incorrect platform inclusion for
	TkplatformtestInit (it would never get called).

	* unix/Makefile.in (MAN_INSTALL_DIR): patch to accept --mandir
	correctly [Bug: 4085]

	* library/clrpick.tcl (tkColorDialog_Config): error now thrown
	when -initialcolor "" specified. [Bug: 4198]

2000-03-31  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/DrawFocHlt.3: doc name correction

	* generic/tkEntry.c: set TK_OPTION_NULL_OK bit on -invcmd option
	and removed #ifdef ENTRY_VALIDATE expressions

	* library/menu.tcl (tkMenuInvoke): corrected naming of tearoffs
	[Bug: 4506]

	* library/tkfbox.tcl (tkIconList_Goto): caused browsecmd to be
	called in tkIconList_Select.  This causes the entry to be set
	properly when using the type-in-name-in-listbox bindings.

	* win/tkWinDialog.c: added unicode-aware open/save file dialogs

	* win/tkWinFont.c (TkpFontPkgInit): move private ref to platformId
	to TkWinGetPlatformId

	* win/tkWinMenu.c (SetDefaults): moved private use of versionInfo
	to TkWinGetPlatformId and removed all code for
	(versionInfo.dwMajorVersion < 4) (== Win32s)

	* win/tkWinX.c:
	* win/tkWin32Dll.c: moved TkWinGetPlatformId to tkWinX.c
	* win/tkWinInit.c: added TkWinXInit to TkpInit to ensure that its
	called for static Windows shells. [Bug: 3647]

	* win/tkWinInt.h:
	* win/tkWinX.c:
	* win/tkWinDraw.c (SetUpGraphicsPort): 
	* win/tkWinScrlbr.c (UpdateScrollbar): removed use of tkpIsWin32s

	* win/tkWinInt.h (TkWinDCState struct): added bkmode value
	* win/tkWinDraw.c (TkWinGetDrawableDC, et al): added support for
	properly transparent dashed lines on Windows. [Bug: 4617]

2000-03-30  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgGIF.c: Fixed some ANSI specific bits to avoid
	compile problems with non-ANSI compilers (ie, replace const with
	CONST, etc).  [Bug: 4223].

	* unix/configure.in: Applied patch from [Bug: 4237]; ensures that
	srcdir is fully qualified.

	* unix/Makefile.in: Applied patch from [Bug: 4237]; if tcltest was
	not compiled, make test/tktest failed.  Now it has a rule to build
	tcltest if it has not been built.

2000-03-28  Eric Melski  <ericm@scriptics.com>

	* library/tkfbox.tcl: Moved an overlooked tkFDialog* function in
	::tk::dialog::file namespace.

	* tests/unixWm.test: Added tests for memory leak conditions in
	tkUnixWm.c.

	* tests/canvas.test: Added test for bad configuration options on
	empty and non-empty canvas.

	* generic/tkCanvas.c: Removed bad code in CANV_CONFIGURE block of
	CanvasWidgetCmd; this was causing non-empty canvases to improperly
	handle bad configuration options [Bug: 4456].

2000-03-27  Eric Melski  <ericm@scriptics.com>

	* unix/tkUnixWm.c: Applied patch from [Bug: 4405]; fixes memory
	leak in Unix wm command.

2000-03-24  Eric Melski  <ericm@scriptics.com>

	* tests/filebox.test: 
	* tests/choosedir.test: Updated tests.

	* library/xmfbox.tcl: Updated to stash data array in
	::tk::dialog::file namespace instead of in global namespace.

	* library/tkfbox.tcl: Extended some functions to support creation
	of a choosedir dialog, to allow greater code reuse between the two
	dialogs.  Moved tkFDialog* functions into a namespace
	(::tk::dialog::file).  Because these are private Tk functions (and
	should thus not be used directly by users), this should not impact
	anybody (the tk_getOpenFile and tk_getSaveFile commands still
	exist at the global scope).

	* library/tk.tcl: 
	* library/tclIndex: Updated function names for tkFDialog*
	functions and choosedir functions.

	* library/choosedir.tcl: New and improved implementation of
	tk_chooseDirectory dialog.  Based on tk_getOpenFile dialog.

2000-03-23  Eric Melski  <ericm@scriptics.com>

	* generic/tkWindow.c: 
	* generic/tkInt.h: Updated Tcl_OptionCmd -> Tcl_OptionObjCmd

	* generic/tkOption.c: Tcl_Obj'ectified the "option" command.

2000-03-22  Eric Melski  <ericm@scriptics.com>

	* library/listbox.tcl (tkListboxCancel): Added a check for empty
	string value for tkPriv(listboxPrev).  Without this check, it's
	possible to get a stack trace under certain conditions. [Bug: 4373].

2000-03-15  Sven Delmas  <sven@scriptics.com>

	* win/tkWinDialog.c: Changed the behavior for the
	tk_chooseDirectory dialog under Windows. Instead of trying to
	return the currently selected listbox entry (which didn't work in
	case the user selected the initial directory anyway), we now
	return the value shown in the entry. This seems to be in
	accordance with the expected behavior for this dialog.

2000-03-14  Eric Melski  <ericm@scriptics.com>

	* tests/choosedir.test: Marked test 3.1 and 3.2 as bad until the
	issue with those tests on IRIX can be determined.

2000-03-10  Eric Melski  <ericm@scriptics.com>

	* library/menu.tcl: Applied patch from [Bug: 4155]; protects
	against grabs on non-viewable windows.

2000-03-08  Eric Melski  <ericm@scriptics.com>

	* tests/choosedir.test: Modified test 3.1 (-mustexist works) to be
	more careful about cleaning up its potentially troublesome after 
	events.

2000-03-07  Eric Melski  <ericm@scriptics.com>

	* tests/button.test: 
	* generic/tkButton.c: Added -disabledforeground/-state to labels.

2000-03-07  Jeff Hobbs  <hobbs@scriptics.com>

	* tests/entry.test:
	* generic/tkEntry.c (EntrySetValue): malloc the value when
	validating because validation could cause the pointer to become
	invalid.  Also fixed configure to not trigger focus-based
	validation.  Improved use of Tcl_WrongNumArgs. [Bug: 4320]

2000-03-06  Eric Melski  <ericm@scriptics.com>

	* library/menu.tcl: Added a check in tkMenuFirstEntry that changes
	menu behavior to only auto-post an immediate child cascade if we
	are currently on a menubar menu.  This prevents massive
	auto-cascading in cases where the first entry of the cascade is
	itself a cascade, and the first entry of that cascade is a
	cascade, and the first entry of that cascade is a cascade
	... [Bug: 676].

	* generic/tkOldConfig.c: Added check for NULL tkwin value in
	Tk_ConfigureWidget [Bug: 4079]

	* generic/tkWindow.c: Added check for NULL tkwin value in
	Tk_NameToWindow [Bug: 4079]

2000-03-02  Jeff Hobbs  <hobbs@scriptics.com>

	* tests/color.test:
	* xlib/xcolors.c (XParseColor FindColor):
	* win/tkWinColor.c (XAllocColor): Fixed bit fiddling for colors to
	return "correct" values for color mapping. [Bug: 4282]

	* unix/Makefile.in (SCRIPT_INSTALL_DIR): removed extraneous '/'
	* unix/aclocal.m4: corrected TCL_NEEDS_EXP_FILE to be 1 for AIX

	* win/tkWinInt.h: change extern to EXTERN for TkWinChildProc
	declaration with extra #defs. [Bug: 4240]

	* library/focus.tcl: fixed tkFocusOK to protect $w in
	uplevel with list. [Bug: 4208]

	* doc/CrtItemType.3: fixed docs for Tk_CreateItemType to reflect
	changes made in 8.3.0 (but old style would still work as well).
	[Bug: 4252]

	* tests/config.test: extra test to check object cleanup when
	destroying the widget
	* generic/tkListbox.c (DestroyListbox): fixed crash in
	DestroyListbox due to null tkwin.  [Bug: 4207]

	* tests/entry.test: added test suite for entry validation
	* doc/entry.n: improved docs discussing caveats and gotchas when
	mixing textvar with widget validation
	* generic/tkEntry.c (EntryValidateChange): improved handling of
	validation with relation to -textvariable.  Previously, it would
	turn off whenever the textvar was set.  Now it will it will turn
	off only when the textvar is set and validation returns 0.  Added
	%V (type of validation occuring) to %-subs to help work with
	trickier validation.

2000-03-01  Eric Melski  <ericm@scriptics.com>

	* tests/clrpick.test: 
	* library/clrpick.tcl: Added code to make color chooser dialog
	inherit screen setting from parent (bug #2334)

2000-02-25  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c (RaiseWinWhenIdle): Checked for the possibility
	that the window could be destroyed (can occur with
	wm deiconify .toplevel; destroy .toplevel).

2000-02-25  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgGIF.c: Applied "spirit of" the patch in 1605 (the
	submitted patch was more complicated than necessary and did not
	extend to writing GIF's, only reading), to allow reading/writing
	of GIF files on EBCDIC and other non-ASCII based systems.

2000-02-14  Eric Melski  <ericm@scriptics.com>

	* unix/tk.spec: RPM specification for producing a binary Tk RPM
	for Linux.

	* unix/Makefile.in: Added rpm target to generate Tk
	binary RPM.

2000-02-10  Jeff Hobbs  <hobbs@scriptics.com>

	8.3.0 RELEASE

	* changes: updated for 8.3.0 release

	* generic/tkImgGIF.c (FileReadGIF): added cast for trashBuffer

	* generic/tkIntXlibDecls.h:
	* generic/tkInt.decls: declared some Xlib emulation calls for
	the Mac

	* generic/tkFrame.c (TkInstallFrameMenu): added extra panic to
	inform user of bad call when framePtr is NULL [Bug: 2530]

	* generic/tkMenu.c (DestroyMenuInstance): Placed checks around
	menu name objects before trying to incr the ref.  [Bug: 3402]

	* generic/tkTest.c: removed USE_OLD_IMAGE def for Mac

	* library/listbox.tcl:
	* library/text.tcl: added support for <4> and <5> for mousewheel
	style scrolling on Unix for mice that map to these buttons.

	* tests/scrollbar.test: fixed check of testmetrics command to
	allow unix tests to run (testmetrics is mac/pc only)

	* unix/tkUnixWm.c (Tk_CoordsToWindow): qualified delete of error
	handler as the goto label is reached from above and below.

	* unix/configure.in:
	* unix/aclocal.m4: cleaned up macros to coincide with tcl.m4,
	added -export-dynamic to LDFLAGS for FreeBSD-3+ [Bug: 2998]

	* unix/README:
	* unix/Makefile.in (dist): removed porting.notes and porting.old
	from distribution and CVS.  The information was very outdated.  Now
	refer to http://dev.scriptics.com/services/support/platforms.html

	* xlib/xgc.c: #def'd out XDrawSegments for the Mac, and added
	some extra include info for the Mac

2000-02-09  Jim Ingham  <jingham@cygnus.com>

	* mac/tkMacButton.c: Stop removing the appearance window from the
	Window List.  It is not clear why Ray did this, and it causes the
	Appearance manager to crash at random times.
	
	* mac/tkMacWM.c: Add support in unsupported1 style for the Appearance
	specification of window styles, including floating window support.
	* mac/tkMacWindowMgr.c: Operate on the front non-floating window,
	unless the mouse is directly over the floating window.  Also,
	keystrokes go to the front non-floating window.
	* mac/tkMacAppInit.c: Initialize floating window support.
	* mac/tkMacScrlbr.c:
	* mac/tkMacmenu.c: Fixes for floating windows - operate on the 
	FrontNonFloatingWindow.
	* mac/tkMacLibrary.r: Fix typo in File info string.
	* mac/tkMacApplication.r: Fix typo in file info string.  Add
	Finder balloon help for no apparent reason.
	
	* mac/tkMacSubwindows.c: Change panic in tkMacGetDrawablePort to
	Debugger.  This is only a temporary fix.  The panic is only
	triggered when a safeTk interpreter is torn down, and ignoring it
	does no harm.  I haven't figured out how to avoid it yet, however.
	Also use the Appearance MoveWindowStructure call when available.
	
	New Files:
	* MW_TkOldImageHeader.h: Handle #defining USE_OLD_IMAGE for tkImgPPM.c.
	* MW_TkTestHeader.h:
	* MW_TkTestHeader.pch:
	* MW_TkHeader.h: Add separate prefix files for test & release
	versions of Tk, so we can just have separate targets w/o having to
	edit files.
	
	* tclets.r: The D&D Tclets icon in rez form so we can have a
	target for this.

	The above are curtesy of Daniel Steffen (steffen@math.mq.edu.au)
	
	* tkMacAppearanceStubs.c: Stubs of the Mac Appearance calls I use
	so I can link the static 68K Shell without putting ifdef's all
	over the code.
	
2000-02-08  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tk.decls:
	* generic/tkBind.c:
	* generic/tkInt.decls:
	* generic/tkIntDecls.h:
	* generic/tkStubInit.c:
	* mac/tkMacKeyboard.c:
	* unix/tkUnixKey.c:
	* win/tkWinKey.c: Fix for keyboard handling of "dead" keys and
	caps lock from Peter Spjuth. [Bug: 4105 3359 2493]
	Split functions into platform specific files:
	Static functions GetKeySym(), SetKeycodeAndState() and InitKeymapInfo()
	from tkBind.c moved into platform files tkWinKey.c tkUnixKey.c and
	tkMacKeyboard.c.  GetKeySym() and SetKeycodeAndState() renamed to 
	Tkp* and made public (as private functions) in tkInt.decls.

	Step 2, fixes in tkWinKey.c
	New static function: KeycodeToKeysym(), based on XKeycodeToKeysym()
	but with different arguments, and a lot of improvements.
	TkpGetString() changed to use KeycodeToKeysym() + other fixes.
	TkpGetKeySym() changed to use KeycodeToKeysym() + other fixes.
	InitKeymapInfo() changed to use KeycodeToKeysym().
	TkpSetKeycodeAndState() rewritten, mostly by copying code from
	XKeysymToKeycode().
	XKeycodeToKeysym() rewritten. Preferably it should be removed.

	EXPLANATION: The main problem is ToAscii() which has a lot of side
	effects, and also that XKeycodeToKeysym() is not provided enough
	input to do a proper job.  The changes' main goal is to avoid
	calling ToAscii() if not necessary, and to provide it with as
	correct information as possible when called.  Also some attempts
	to clean up what ToAscii() did are done.  See the code for details.

	BUGS FIXED: Typing shifted (and AltGr) dead keys did not work.
	Keyboard lock lamps did not work on Win98.
	Events regarding AltGr-keys behaved badly.
	Example: On a Swedish keyboard, $ is typed with AltGr-4.
	That keyboard event would get the keysym '4' not 'dollar'.
	Also, doing [event generete . <Key-dollar>] would send keysym '4'.
	Translation to ascii in TkpGetString did not handle return and
	tab correctly. I.e. [event generate . <Key-Return>] gave wrong %A

	* generic/tkDecls.h:
	* generic/tk.decls:
	* generic/tk.h: moved new public functions created in dash patch
	to the stubs interface [Bug: 4062]

	* generic/tk.h: 
	* doc/CrtImgType.3:
	* doc/CrtPhImgFmt.3:
	* generic/tk.h:
	* generic/tkImgGIF.c:
	* generic/tkImgPhoto.c:
	* generic/tkStubImg.c (new file):
	* generic/tkTest.c:
	* unix/Makefile.in:
	* win/Makefile.in:
	* win/makefile.vc: improved support for moving from the old style
	image C API to the new obj'ified one with new Tk_InitImageArgs
	command and stub'ing of image code.  See docs for how to make the
	transition. [Bug: 4060]

	* library/tk.tcl: wrapped check for tcl_platform(os) around info
	exists because it won't in safe interpreters

	* win/tkWinFont.c: corrected symbol font use to only work on 8-bit
	characters [Bug: 2406]

	* unix/aclocal.m4: changed all -fpic to -fPIC

	* README:
	* unix/configure.in:
	* win/configure.in:
	* generic/tk.h (TK_RELEASE_SERIAL): Moved to 8.3.0 patchlevel

2000-02-07  Eric Melski  <ericm@scriptics.com>

	* library/tkfbox.tcl: Applied patch from bug #4117,
	tk_getOpenFile/getSaveFile doesn't do the right thing when user
	types a directory name in the entry and a default extension is
	specified.

2000-02-05  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/tkUnixScale.c (TkpDestroyScale): changed ckfree to
	Tcl_EventuallyFree to behave with Tcl_Preserve in TkpDisplayScale
	(prevents possible segfault).

2000-02-03  Eric Melski  <ericm@scriptics.com>

	* tests/canvText.test: test for fix for bug #2525.

	* generic/tkFont.c (Tk_ComputeTextLayout): Was erroneously setting
	the width of newline-only text display chunks to some arbitrary
	huge number, instead of 0; this was interfering with things like
	the canvas find enclosed feature. (bug #2525).

	* tests/text.test: 
	* generic/tkText.c (DumpLine/DumpSegment): Changed DumpSegment to
	take a TkTextIndex instead of two integer offsets, so that it
	could use TkTextPrintIndex to format the offsets into an index,
	which makes it UTF smart (bug #2582).

2000-02-01  Eric Melski  <ericm@scriptics.com>

	* library/tk.tcl: 
	* library/tclIndex: 
	* library/choosedir.tcl: Moved choosedir functions into the
	::tk::dialog::chooseDir namespace instead of a toplevel
	::tkChooseDirectory namespace.  Additional cleanup on the
	chooseDir dialog.

2000-02-01  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/text.n: clarified docs on what happens during a search with
	-count when images/windows are embedded

	* win/Makefile.in (install-*): reduced verbosity of install

	* win/tkWinPixmap.c (XGetGeometry): added support for windows in
	XGetGeometry [Bug: 4069]

	* win/tkWinFont.c (GetScreenFont): fixed possible mem overrun with
	long font names [Bug: 4108]

	* win/tkWinDialog.c: added EnableWindow calls to dialogs to
	correct for possible loss of control in parent Tk toplevel
	[Bug: 1212 et al]

	* generic/tkRectOval.c (ConfigureRectOval): 
	* generic/tkCanvLine.c (ConfigureLine): 
	* generic/tkCanvPoly.c (ConfigurePoly): 
	* generic/tkCanvArc.c (Configure/DisplayArc): fixed handling for
	negative dash values [Bug: 4104]

	* generic/tkScale.c (TkRoundToResolution): fixed incorrect
	assumption that (N+1)*delta = N*delta + delta with floating point
	math [Bug: 3689, 4099]
	(DestroyScale) Fixed check for cancelling TkpDisplayScale (was
	REDRAW_ALL, is now REDRAW_PENDING)

	* tests/listbox.test: corrected test case for listbox itemconfigure

	* unix/aclocal.m4: added *BSD ELF recognition for
	SHARED_LIB_SUFFIX determination (from Tcl's tcl.m4)

2000-01-27  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgPhoto.c: Removed unneccesary object translation in 
	MatchStringFormat (bug #4103).

2000-01-27  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgGIF.c: Additional code cleanup (now we only have
	one decoder!  neat!)

2000-01-26  DJ Delorie  <dj@cygnus.com>

	* win/tkWin32Dll.c (DllMain): Use _imp__ instead of __imp_

2000-01-26  Eric Melski  <ericm@scriptics.com>

	* doc/getOpenFile.n: 
	* doc/chooseDirectory.n: Man page/cross links for
	tk_chooseDirectory (bug #1786).

	* library/tk.tcl: 
	* library/tclIndex: Added hooks for tk_chooseDirectory. (bug #1786)

	* library/choosedir.tcl: tk_chooseDirectory implementation for
	Unix/Mac (bug #1786).

	* generic/tkImgPhoto.c: Added some comments regarding slow
	processing of transparent images.

	* generic/tkImgGIF.c: Improved GIF decoder for ~60% speed
	increase.  Added some comments on how to further improve the
	implementation, time permitting.

	* doc/photo.n: Added a description of what the -data string can
	contain (base64 or binary data).

	* generic/tkImgPhoto.c: Fixed bug with use of binary data for
	"-data" option to "image create" command.

2000-01-21  Eric Melski  <ericm@scriptics.com>

	* library/tkfbox.tcl: Fixed bug relating to incorrect parent
	values for error message boxes displayed by the file dialog (bug
	#3616).

	* tests/text.test: 
	* generic/tkText.c: Fixed bug relating to regexp searching for
	empty lines; previously, the starting line was ignored. (bug #1643).

2000-01-20  Jeff Hobbs  <hobbs@scriptics.com>

	* library/text.tcl: fixed double-click selection behavior where
	there were embedded windows/widgets in the same line. [Bug: 3989]

	* win/tkWinWm.c (TkWmProtocolEventProc): cached atom name as the
	window could get destroyed during eval [Bug: 2513]

	* generic/tkCanvLine.c (LineCoords): fixed segfault when too few
	coords were passed to a line with certain options set (it should
	always have thrown an error anyway). [Bug: 4042]

	* tests/text.test:
	* generic/tkText.c: fixed missing " in error case and missing
	'dump' in subcommand listing [Bug: 4036]

	* generic/tkListbox.c: adjusted use of basic string concatenation
	in (non-K&R behavior) [Bug: 4027]
	Swapped bg/fg class for -select(bg|fg) for listbox and their
	items [Bug: 4039]

	* unix/mkLinks:
	* doc/WindowId.3: added docs for Tk_IsContainer and Tk_IsEmbedded

	* doc/text.n: clarified mark gravity definition and usage of
	``word'' in binding definitions.  [Bug: 2004 2277 1388]

	* generic/tkInt.h: moved new TkDisplay useInputMethods structure
	element to end to not disturb position of previous elements in
	the structure (as compared to Tk <=8.2).

2000-01-20  Eric Melski  <ericm@scriptics.com>

	* tests/grid.test: Added a test for the consecutive ^ and multiple
	widget case (bug #1386).

	* generic/tkGrid.c: Fixed interpretation of consecutive ^
	characters in grid command.  Previously, ^ ^ was interpreted as
	meaning that there must be a 2-column widget above to extend,
	neglecting the case where there was actually 2 1-column widgets
	above.  Now, ^ ^ is interpreted as a possible width; the gridder
	will consume as many ^'s as there are columns in the widget, and
	leave the rest for the extension of other widgets.  (bug #1386).

2000-01-19  Eric Melski  <ericm@scriptics.com>

	* library/tk.tcl: Created a virtual event <<PrevWindow>> for
	reverse tab traversals, with one default binding <Shift-Tab>, and
	OS specific bindings for Linux, HP-UX, and IRIX. (bug #3163)

2000-01-13  Jeff Hobbs  <hobbs@scriptics.com>

	* changes: updated changes file to reflect 8.3b2 mods
	* README:
	* generic/tk.h:
	* unix/configure.in:
	* win/configure.in: updated to patchlevel 8.3b2

	* win/tkWinWm.c: added visibility event handler to make sure
	that transient window wrappers would be updated when the master
	was initially mapped.

2000-01-12  Jeff Hobbs  <hobbs@scriptics.com>

	* tests/text.test: changed test to reflect change of -hidden
	to -elide in search options.

	* win/tkWinScrlbr.c: added check for valid hwnd in ModalLoopProc
	to avoid crash when building statically

	* doc/event.n:
	* generic/tkBind.c: prevented core with event -warp on Windows
	when window wasn't mapped [Bug: 4004] and added docs stating
	the requirement for mapped windows.

	* generic/tkCanvas.c: fixed mem leak with TagSearchExprInit
	[Bug: 3977]

	* generic/tkStubInit.c:
	* generic/tkDecls.h: remove non-existent
	Tk_(Get|Create)CanvasVisitor prototypes

	* generic/tkText.c:
	* generic/tkEntry.c: fixed cursor to not blink when widget was
	disabled [Bug: 1807]

	* generic/tkRectOval.c: added note about change to bloat for
	RectOval bounds calculation for WIN32 only

	* library/dialog.tcl: improved handling of $default arg to allow
	for name of given button, as well as bounds checking

	* doc/wm.n:
	* tests/winWm.test:
	* tests/unixWm.test:
	* mac/tkMacWm.c:
	* unix/tkUnixWm.c: fixed possible X error being raised [Bug: 3377]
	* win/tkWinWm.c: wm deiconify in zoom state [Bug: 2077],
	fixed possible flashing of unmapped toplevel in deiconify [Bug: 3338]
	and fixed mapping of transient window [Bug: 572]
	Also, for all wm's, extended 'wm state' command to allow setting
	of the state, and added official support of 'zoomed' state on Win.

	* unix/aclocal.m4: strtod bug on Tru64 [Bug: 3378]

	* unix/Makefile.in: added tests to prevent unnecessary chmod +x
	in source dirs while installing [Bug: 3367]

	* unix/configure.in: properly sub'ed in TK_SHARED_BUILD [Bug: 3385]

2000-01-05  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/text.n:
	* generic/tkText.c:
	* generic/tkText.h:
	* generic/tkTextBTree.c:
	* generic/tkTextDisp.c:
	* generic/tkTextTag.c: removed the -state option for text tags,
	and reoriented it around -elide, as -state disabled was never
	implemented, and -state hidden is better as -elide.

	* mac/tkMacClipboard.c: fixed i18n problems with clipboard [Bug: 3544]

	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: fixed unprotected arg parsing through eval/after
	[Bug: 3943]

	* unix/Makefile.in: added unix/aclocal.m4 to distribution [Bug: 3938]
	* unix/aclocal.m4: changed NetBSD SHLIB_CFLAGS from -fpic to -fPIC

	* win/tkWinImage.c: added static declaration to function

1999-12-22  Jeff Hobbs  <hobbs@scriptics.com>

	* changes: updated changes file

	* generic/tkScale.c:
	* generic/tkScale.h:
	* mac/tkMacScale.c:
	* unix/tkUnixScale.c: fixed potential segv from patch in 3897

	* tests/unixWm.test: nonPOrtable -> nonPortable

1999-12-21  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tk.h:
	* unix/configure.in:
	* win/configure.in:
	* win/aclocal.m4:
	* README: updated for patch level 8.3b1

	* unix/tkUnixWm.c: fixed panic in Tk_CoordsToWindow to print error
	and continue instead (for Tix) [Bug: 716 et al]

	* scale.test:
	* generic/tkScale.c:
	* generic/tkScale.h: fixed possible core when freeing options
	(cursor) associated with scale widget [Bug: 3897]

	* doc/MeasureChar.3: fixed docs for Tk_MeasureChars to reflect code
	* doc/listbox.n: fixed formatting problem

	* generic/tk3d.c: added extra calculations to ensure that thin
	frames get refreshed too [Bug: 3596]

	* unix/tkUnixMenu.c:
	* unix/tkUnixFont.c:
	* generic/tkCanvText.c:
	* generic/tkEntry.c:
	* generic/tkFont.c:
	* generic/tkImgPPM.c: removed extranneous vars that were set but
	never used.

	* mac/tclMacHLEvents.c: fixed applescript for I18N [Bug: 3644]

	* unix/aclocal.m4: removed -O flag for AIX when using the IBM
	compiler (several versions have a bug that crops up in the text
	widget). [Bug: 2316]

	* unix/Makefile.in: removed extra slash in SCRIPT_INSTALL_DIR
	[Bug: 3896]

	* library/listbox.tcl: added extra checks for existence of
	tkPriv(listboxSelection) before it was used. [Bug: 3892]

1999-12-16  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/GetCursor.3:
	* win/tkWinCursor.c: added support for Windows cursors to
	TkGetCursorByName (.ani, .cur) using -cursor @<filename>
	(Ascher) [Bug: 1350]

	* win/tkWinWm.c: fixed 'wm deiconify' to update position of the
	toplevel if event is waiting before mapping. (Mao) [Bug: 3687]
	This removes the need for 'update idle' before 'wm deiconify' on
	Windows.

	* doc/listbox.n: added doc for <<ListboxSelect>> [Bug: 3500]

	* doc/getOpenFile.n: removed note that -initialfile didn't work
	for tk_getOpenFile
	* library/tkfbox.tcl: updated tk_get*File to better match the
	Windows file box it emulates, give proper support to -initialfile,
	and fixes lack of global tkPriv call.  [Bug: 3735 3882]

	* doc/tk.n: added doc for 'tk useinputmethods ...'
	* tests/tk.test:
	* unix/tkUnixKey.c:
	* generic/tkCmds.c:
	* generic/tkEvent.c:
	* generic/tkWindow.c:
	* generic/tkInt.h: add 'tk useinputmethods ?-display win? ?bool?'
	call to provide support for disabling/enabling the use of XIM on
	X.  This was previously all done at compile time, and always on.
	Now it is turned off by default, even when available, and the user
	must turn it on to use XIM (per display).

	* generic/tkCanvUtil.c: fixed bug in Tk_CanvasPsOutline that freed
	mem it shouldn't.

	* generic/tkFont.c: added "bitstream cyberbit" (popular Windows
	CJK font) to list of font fallbacks. (kenny) [Bug: 2407]

	* mac/tkMacMenu.c: finished bug 3075 by changing the char values of
	what was checked (verified correctness on Mac).

1999-12-13  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/canvas.n: added docs for items added by dash patch (-*dash*,
	-state, -active*, -disabled*, -offset, essentially rewrote the
	man patch for completely updated 8.3 canvas widget.
	* doc/entry.n: added docs for entry widget validation
	* doc/event.n: added docs for -warp
	* doc/text.n: doc'ed new -state value 'hidden'
	* doc/GetDash.3: (new file) man page explaining Tk_GetDash
	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkInt.decls: added XSetDashes and XWarpPointer
	* generic/tk.decls: added Tk_CreateSmoothMethod, and reserved
	two spots
	* generic/tk.h: added Tk_SmoothMethod struct,
	state item to canvas record, #defines for item state,
	support for using old char*-based canvas item C creation
	procedures with -DUSE_OLD_CANVAS,
	Tk_Dash, Tk_TSOffset (-offsets) & Tk_Outline structs and #defs,
	decls for dash, outline and postscript routines
	* generic/tkBind.c: added support for Quadruple clicks, and added
	the -warp option to 'event' with pointer warping routines
	* xlib/xgc.c:
	* generic/tkRectOval.c:
	* generic/tkCanvArc.c:
	* generic/tkCanvBmap.c:
	* generic/tkCanvImg.c:
	* generic/tkCanvLine.c:
	* generic/tkCanvPoly.c:
	* generic/tkCanvPs.c:
	* generic/tkCanvText.c:
	* generic/tkCanvUtil.c:
	* generic/tkCanvWind.c:
	* generic/tkCanvas.c:
	* generic/tkCanvas.h: Canvas and items received overhaul to with
	the addition of the dash patch (Nijtmans, et al)  This includes
	objectification of the 'canvas' command, as well as support for
	(where appropriate) dashes in items, extended stipple support,
	state for all items, and postscript generation of images and
	windows.  See the new canvas man page for related docs.
	* generic/tkEntry.c: added entry widget validation, see entry.n
	* generic/tkEvent.c: on simulated events, ButtonPress should
	be matched with ButtonRelease to be correct
	* generic/tkFont.c: corrected possible null reference
	* generic/tkFrame.c: made frame a Tcl_Obj based command
	* generic/tkGet.c: added TkGetDoublePixels
	* generic/tkImage.c: bug fixes from Img patch and new
	Tk_PostscriptImage and Tk_SetTSOrigin functions
	* generic/tkImgBmap.c: new ImgBmapPostscript function
	* generic/tkImgPhoto.c: new Tk_CreatePhotoOption, Tk_DitherPhoto
	* generic/tkInt.h: declarations for some new functions
	* generic/tkMessage.c: reworked relief drawing
	* generic/tkOldConfig.c: added TK_CONFIG_OBJS so old style
	ConfigureWidget calls can pass in Tcl_Obj arrays
	* generic/tkScrollbar.c:
	* generic/tkScrollbar.h: made -orient use an option table
	* generic/tkText.c:
	* generic/tkText.h: made -wrap and -state use option tables
	* generic/tkTextBTree.c:
	* generic/tkTextDisp.c:
	* generic/tkTextImage.c:
	* generic/tkTextMark.c:
	* generic/tkTextTag.c:
	* generic/tkTextWind.c: added support for -elide and -state hidden
	* generic/tkTrig.c: changed TkMakeBezierCurve to support returning
	the upper limit of points needed for spline
	* generic/tkUtil.c: new option table parsing routines
	* generic/tkWindow.c: init'ing of warp stuff, mouseButtonState

	related bug ids for the fixes:
	[Bug: 648 1541 1540 1779 2168 2311 2297 2340 2348 2578 3386]

	* tests/bind.test:
	* tests/canvImg.test:
	* tests/canvPsArc.tcl:
	* tests/canvPsImg.tcl: (new file)
	* tests/canvRect.test:
	* tests/canvText.test:
	* tests/canvas.test:
	* tests/defs.tcl:
	* tests/entry.test:
	* tests/event.test:
	* tests/font.test:
	* tests/frame.test:
	* tests/imgPhoto.test:
	* tests/safe.test:
	* tests/scale.test:
	* tests/scrollbar.test:
	* tests/select.test:
	* tests/text.test:
	* tests/textDisp.test:
	* tests/textTag.test:
	* tests/unixFont.test:
	* tests/unixWm.test:
	* tests/visual_bb.test:
	* tests/winClipboard.test: tests for the dash patch changes

	* unix/mkLinks: added GetDash.3 into the mkLink step

	* mac/tkMacDraw.c: mac still needs pointer warping routine
	* mac/tkMacXStubs.c:
	* win/tkWinDraw.c:
	* win/tkWinPointer.c: added support for pointer warping and
	platform specific support for dash patch items

1999-12-12  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkText.c: fixed bug in TextSearchCmd for multibyte chars
	(Darley) [Bug: 3839]

	* unix/aclocal.m4: added warning when configuring with
	--enable-threads that Tk may have problems

1999-12-09  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkImgGIF.c: updated casting

	* win/makefile.vc: removed 16bit stuff, simplified makefile.

1999-12-06  Scott Redman  <redman@scriptics.com>

	* generic/tkMain.c: need to include tclInt.h for new hook
	functions that are internal-use-only.

1999-12-06  Jeff Hobbs  <hobbs@scriptics.com>

	* library/comdlg.tcl: removed tclVerifyInteger and tclSortNoCase,
	they weren't used, and were not actually correct

	* mac/tkMacFont.c:
	* mac/tkMacMenu.c:
	* mac/tkMacWindowMgr.c: fixed greyed out menu items, handling of
	... elipsis, font mapping problem, and enabled generated menu
	posting [Bug: 3705]

1999-12-02  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkInt.h:
	* generic/tkWindow.c:
	* generic/tkCmds.c: converted Tk_DestroyCmd, Tk_LowerCmd and
	Tk_RaiseCmd to their ObjCmd equivalent.

	* library/msgbox.tcl: added color icons for tk_messageBox on Unix
	and Mac when tk_strictMotif isn't set. (Hipp)
	* library/tk.tcl: added window bounds checking to ::tk::PlaceWindow

	* tests/imgPPM.test: fixed test 2.2 to use -format ppm (since
	we know have GIF write capability)

1999-12-01  Scott Redman <redman@scriptics.com>

	* generic/tkMain.c :
	* unix/tkAppInit.c: 
	* win/winMain.c: Added added hooks into the main() code for
	supporting TclPro and other "big" shells more easily without
	requiring a copy of the main() code.

1999-11-29  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkImgGIF.c: added GIF writing that uses miGIF RLE
	[Bug: 2039, new patch]

	* library/entry.tcl: fixed up tkEntrySeeInsert (Nemthi)

	* generic/tkListbox.c: fixed 'get' of listbox to return a string
	when only one item is requested.

	* tests/clrpick.test:
	* tests/filebox.test: minor whitespace cleanup

	* library/tk.tcl: fixed missing $w in ::tk::PlaceWindow

1999-11-24  Jeff Hobbs  <hobbs@scriptics.com>

	* library/clrpick.tcl:
	* library/msgbox.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: fixed dialogs to center over -parent,
	added utility functions ::tk::PlaceWindow, ::tk::SetFocusGrab,
	::tk::RestoreFocusGrab to tk.tcl to help

1999-11-23  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Added a test to check that the topIndex is
	update when items are removed from the listvar variable.

	* generic/tkListbox.c: Added a check the updates the topIndex when
	items are removed from the listvar variable.

	* tests/listbox.test: Added a test to check that the vertical
	scrollbar is updated when the listvar changes.

	* generic/tkListbox.c (ListboxListVarProc): added a check that
	sets the UPDATE_V_SCROLLBAR flag if the length of the listvar has
	changed.

1999-11-23  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tk.h:
	* generic/tkConfig.c: added support for TK_OPTION_DONT_SET_DEFAULT
	as equiv for TK_CONFIG_DONT_SET_DEFAULT
	* generic/tkListbox.c: added TK_OPTION_DONT_SET_DEFAULT to the
	item specs

1999-11-19  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkColor.c:
	* generic/tkColor.h: fixed Tk_NameOfColor to work correctly,
	with minor change to TkColor struct.

	* generic/tkConsole.c: added static declaration to
	ConsoleDeleteProc function (proto already had it)

	* win/tkWinInt.h: removed TkFontAttributes typedef (was
	redundant with tkFont.h).
	* win/tkWinPort.h: put #ifndef __GNUC__ around redefinition
	of str[n]casecmp, as cygwin uses the originals.
	* win/tkWinX.c: changed GetCurrentTime to GetTickCount (the
	former is deprecated).  [Bug: 2053]

1999-11-19  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Added tests for itemcget and itemconfigure.

	* doc/listbox.n: Added documentation for -listvar option and for
	itemconfigure and itemcget commands.

	* generic/tkListbox.c: Added support for itemconfigure/itemcget
	listbox subcommands (addresses rfe #936)

1999-11-17  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Updated tests for new error messages.

	* generic/tkListbox.c: Improved error messages for bad -listvar's.

	* tests/listbox.test: Added tests for bad -listvar's.

	* generic/tkListbox.c: Added handlers for bad -listvar's (ie, bad
	lists)

	* tests/listbox.test: Added tests for ListboxUpdateHScrollbar.

	* generic/tkListbox.c: Changed some old static buffers to base
	size on TCL_DOUBLLE_SPACE instead of (completely) hardcoding the size.

	* tests/listbox.test: New tests for -listvar functionality, and an
	odd extra case that wasn't covered before.

	* generic/tkListbox.c: Tests exposed some bugs, now fixed.

1999-11-16  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Fixed tests to comply with new objectified
	error messages.  No -listvar specific tests yet.

	* win/tkWinDefault.h: 
	* unix/tkUnixDefault.h: 
	* mac/tkMacDefault.h: Added default value for -listvar option.

	* generic/tkWindow.c: Changed "listbox" mapping from old-school to
	new-school objectified command.

	* generic/tkListbox.c: Objectified listbox; added support for
	-listvar option.  Converted internal structure to use a Tcl list
	object to store the data.

	* generic/tkInt.h: Changed reference to Tk_ListboxCmd to
	Tk_ListboxObjCmd.

1999-11-09  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkGrid.c: changed Tcl_Alloc to ckalloc

	* generic/tkEntry.c: fixed C expr error in destroy of entry
	that could lead to 'malformed bucket chain' error

	* win/winMain.c: corrected winMain to not do a DebugBreak when
	returning an error message from the top level

1999-10-30  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinKey.c: fixed XKeysymToKeycode to handle mapping of
	symbolic keysyms (Left, Home, ...) with event generate

	* library/entry.tcl: change tkEntrySeeInsert to avoid the use
	of a while loop that could eat CPU tremendously.  Behavior of
	moving the cursor at the right edge changes slightly (previously
	it tried to keep the cursor at the right edge, now it moves the
	cursor to a "central right" location - better IMHO).

1999-10-28  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/CrtImgType.3:
	* doc/CrtPhImgFmt.3:
	* doc/FindPhoto.3:
	* doc/photo.n:
	* generic/tk.h:
	* generic/tkCmds.c:
	* generic/tkImage.c:
	* generic/tkImgBmap.c:
	* generic/tkImgGIF.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c:
	* generic/tkInt.h:
	* generic/tkTest.c:
	* generic/tkWindow.c:
	* tests/imgPhoto.test: added Img patch (Nijtmans) with docs,
	headers #def'd with USE_OLD_IMAGE.  Upgrades image stuff to
	Tcl_Obj API, adds alpha channel (images are now 32 bpp)

	* makefile.vc: changed 'c:/program files' to c:/progra~1

1999-10-19  Jeff Hobbs  <hobbs@scriptics.com>

	* library/scrlbar.tcl: changed tkScrollButtonUp to check for
	existence of tkPriv(relief) in order to avoid spurious release
	events

	* unix/Makefile.in: added ChangeLog to dist archive

1999-09-24  Jeff Hobbs  <hobbs@scriptics.com>

	* */README:
	* win/makefile.vc:
	* */configure.in:
	* generic/tk.h:
	* library/tk.tcl: up'd to 8.3a1

	* unix/Makefile.in: changed 'mkdir' to 'mkdir -p'

	* library/dialog.tcl: changed {Times 18} to {Times 12} for
	dialog font.

1999-09-16  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkFont.c: fixed processing of font options and error
	returned [Bug: 2075]

	* win/tkWinWm.c: fixed bug in 'wm deiconify' that raised the
	wrong toplevel, and changed it to not set focus on overridden
	toplevels

1999-09-15  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/aclocal.m4: added fix for FreeBSD-[1-2] recognition [Bug: 2070]
	and fix to AIX-* to get ldAix right [Bug: 2624], fixed AIX
	version check (readjust from 8-21 fix) and several other config
	fixes for AIX
	* mac/tkMacMenubutton.c:
	* unix/tkUnixMenubu.c: fixed permanently stippled menubutton image
	* win/tkWinButton.c: fixed possible pointer smash [Bug: 2733]

1999-09-14  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinMenu.c: fix for stack overrun in GetTextFace [Bug: 909]

1999-09-01  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinDraw.c:
	* unix/tkUnixDraw.c: fixed header style for TkpDrawHighlightBorder
	* generic/tkCanvas.c: fixed GC error (bg <> fg) in tkCanvas.c
	(from code added to support TkpDrawHighlightBorder) [Bug: 2676]
	* unix/aclocal.m4: added -bnoentry to the AIX-* flags
	* library/msgbox.tcl: changed the behavior of tk_messageBox on
	Unix to be more Windows like in handling of <Return> and the
	default button
	* library/button.tcl:
	* library/clrpick.tcl:
	* library/comdlg.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/palette.tcl:
	* library/safetk.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: updated commands to use [string] ops
	instead of expr equality operators

1999-08-21  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/aclocal.m4: Changed AIX-4.[2-9] check to AIX-4.[1-9]
	[Bug: 1909]

1999-08-20  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkCursor.c: fixed bug in GetCursorFromObj that caused
	panic [Bug: 2562]

	* TK 8.2.0 RELEASED

1999-08-13  Jim Ingham  <jingham@cygnus.com>

	* mac/tkMacMenu.c: Tk_DrawChars ends up setting the menu background
	wrong.	There is no clean way to stop it, so I use lower level routines
	here to draw the text.
	* mac/tkMacProjects.sea.hqx: Rearrange the projects so that the build 
	directory is separate from the sources.  Much more convenient! 
        
1999-08-10  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c: changed "wm deiconify" on Windows to raise and
	force the focus on the deiconified window (behavioral change from
	8.1 to comply better with Windows style) [Bug: 1609]
	* doc/wm.n: clarified behavior of "wm deiconify".
	* generic/tkInt.decls: added TkSetFocusWin
	* generic/tkFocus.c: changed static SetFocus to TkSetFocusWin

	* library/clrpick.tcl:
	* library/console.tcl:
	* library/tk.tcl: fixed code where abbreviations where used
	in calling widget methods (confuses iWidgets) [Bug: 2422]

1999-08-09  Jeff Hobbs  <hobbs@scriptics.com>

	* library/button.tcl: cleaned up programming (config -> configure)
	and fixed Windows relief bug [Bug: 664]
	* library/entry.tcl: changed Entry C/C/P to not use global data
	(now uses tkPriv(data)) [Bug: 1475]
	* library/listbox.tcl: fixed extended mode script error [Bug: 866]
	* doc/options.n: clarified that -troughcolor doesn't work on Windows
	* doc/wm.n: fixed wm positionfrom docs [Bug: 2284]

1999-08-01  Jeff Hobbs  <hobbs@scriptics.com>

	* mac/tkMacPort.h: wrapped panic in #ifndef panic to avoid
	compiler errors when used with stubs-#defines, from Vince Darley.
	[Bug: 2389]
	
1999-07-31  Scott Redman  <redman@scriptics.com>

	* xlib/X11/Xlib.h: Remove XFillRectangle since it is now in the
	stub tables.

1999-07-30  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkInt.decls: Added stub entry for XFillRectangle [Bug: 2446]

1999-07-30    <redman@scriptics.com>

	* win/makefile.vc: Corrected building threaded tktest.exe on
	Windows.  Needed to link in .obj files from Tcl, needs to change
	later so that code is in Tk and doesn't require a Tcl build.
	Also added runtest target.

1999-07-29    <redman@scriptics.com>

	* generic/tkConsole.c: Allow tcl to open CON and NUL, even for std
	channels.  Checking for bad/unusable std channels was moved to Tk
	since its only purpose was to check whether to use the Tk Console
	Window for the std channels.  [Bug: 2393 2392 2209 2458]

	* win/Makefile.in: Corrected building threaded tktest.exe on
	Windows.  Needed to link in .obj files from Tcl, needs to change
	later so that code is in Tk and doesn't require a Tcl build.

1999-07-22    <redman@scriptics.com>

	* Changed version to 8.2b2

	* win/tkWinPort.h: Block out include of sys/stat.h in order to
	build extensions with MetroWerks compiler for Win32. [Bug: 2385]
	
	* unix/Makefile.in: Need to make install-sh executable before
	calling (with chmod +x).  [Bug: 2413]
	
	* library/menu.tcl: Applied patch from Jeff Hobbs to fix typo.
	[Bug: 2425]
	
1999-07-21    <redman@scriptics.com>

	* unix/Makefile.in: Add Windows configure script to distribution.

1999-07-16    <redman@scriptics.com>

	* unix/Makefile.in:
	* win/Makefile.in:  Copy the prolog.ps from the generic directory
	for install-libraries.

	* unix/aclocal.m4: Check for Alpha/Linux to set the IEEE flag to
	the compiler to be -mieee.  Patch from Don Porter.

1999-07-08    <stanton@scriptics.com>

	* tests/unixSelect.test: Fixed broken test.

	* win/makefile.vc: Added special case target to ensure that 
	tkStubLib.obj is built with -DSTATIC_BUILD.

	* win/tkWinX.c (TkWinChildProc): Changed to pass
	WM_WINDOWPOSCHANGED through to DefWindowProc to make OpenGL
	sub-windows happy.  This allows Windows to generate the WM_SIZE
	and WM_MOVE messages.

1999-07-08    <redman@scriptics.com>

	* unix/configure.in: Fix Tk stub lib file names and flags.

1999-06-30    <redman@scriptics.com>

	* generic/tkGrid.c: removed deprecated functions (applied patch
	from Jan Nijtmans). [Bug: 2080]

	* generic/tkImgGIF.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c: Applied patch to allow Img extension to
	work with 8.2, from Jan Nijtmans. [Bug: 2068]

	* win/tkWinWm.c: Applied patch from Don Porter to prevent the
	windows code from calling the Tcl functions when the stub table
	has not been initialized in TkWinWmCleanup.  [Bug: 2269]
	
1999-06-16    <wart@scriptics.com>

	* unix/configure.in:
	* unix/Makefile.in:
	* unix/aclocal.m4: Numerous build changes to make Tk conform to
	the proposed TEA spec

	* tkConsole.c: changed some variable types from (int) to (size_t)
	to prevent compiler warnings.  Cast return value from strlen()
	to (int) in one place for the same reason.

1999-06-03    <stanton@scriptics.com>

	* unix/tkUnixSelect.c: 
	* tests/unixSelect.test: 
	* generic/tkSelect.c: Fixed selection code to handle Unicode data
	in COMPOUND_TEXT and STRING selections. [Bug: 1791]

1999-06-02    <stanton@scriptics.com>

	* generic/tkIntXlibDecls.h: 
	* xlib/X11/Xlib.h: Added Mac specific defines to help with
	compilation. 

	* generic/tkFont.c: lint

1999-06-01    <stanton@scriptics.com>

	* unix/tkUnixSelect.c: Improved I18N selection support.
	COMPOUND_TEXT is converted to/from iso2022, and STRING is
	converted to/from iso8859-1.  There are still a few loose ends to
	tie up before this is completely done.

	* unix/tkUnixFont.c: Eliminated redundant case folding code.

	* generic/tkFont.c: Eliminated use of isupper/tolower in favor of
	Unicode variants.

1999-05-24    <stanton@scriptics.com>

	* generic/tkStubLib.c: 
	* generic/tkStubInit.c:
	* generic/tkIntXlibDecls.h: 
	* generic/tkIntPlatDecls.h: 
	* generic/tkIntDecls.h: 
	* generic/tkInt.decls: 
	* generic/tkConsole.c: Various changes to try to get the Mac
	builds working.

1999-05-21    <stanton@scriptics.com>

	* win/tkWinClipboard.c: Fixed clipboard code to handle lack of
	CF_LOCALE information (e.g. from command.com).

1999-05-20    <redman@scriptics.com>

	* library/console.tcl: Changed copyright string to read 1999
	Scriptics Corp. in wish console about box.
	
1999-05-19    <redman@scriptics.com>

	* generic/tk.h: Add extern "C" block around entire header file for
	C++ compilers to fix linkage issues.  Submitted by Don Porter and
	Paul Duffin.

1999-05-18    <stanton@scriptics.com>

	* tests/winClipboard.test: 
	* win/tkWinClipboard.c: Fixed clipboard code so it handles Unicode
	data properly on Windows NT and 95. [Bug: 1791]

1999-05-07    <stanton@scriptics.com>

	* library/menu.tcl: Fixed bug where tk_popup fails when called too
	quickly. [Bug: 2009]

1999-04-30    <stanton@scriptics.com>

	* Changed version number to 8.1.1.

1999-04-30    <stanton@scriptics.com>

	* Merged changes from 8.1.0 branch:

	* generic/tkDecls.h: 
	* generic/tkIntDecls.h: 
	* generic/tkIntPlatDecls.h: 
	* generic/tkIntXlibDecls.h: 
	* generic/tkPlatDecls.h: 
	* generic/tkStubInit.c: Changed to avoid the need for forward
	declarations in stub initializers.  Added extern "C" blocks around
	stub table pointer declarations so the stubs can be used from C++
	code. [Bug: 1934]

	* generic/tkInt.decls: Added TkClipBox, XDrawSegments, and
	XForceScreenSaver to stubs.

	* generic/tkStubLib.c: Reordered declarations to avoid
	circularities and forward references.

	* generic/tkStubInit.c: Added includes for Mac.

	* generic/tkMenubutton.c: lint

	* generic/tkEntry.c: Fixed bad option table entry.

	* generic/tkImgBmap.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c: Set the -translation and -encoding options
	to binary for image files. (reported by Marco Gazzetta)
	
1999-04-23    <stanton@scriptics.com>

	* generic/tkInt.decls: Added TkClipBox, XDrawSegments, and
	XForceScreenSaver to stubs.

	* generic/tkStubLib.c: Reordered declarations to avoid
	circularities and forward references.

	* generic/tkStubInit.c: Added includes for Mac.

	* generic/tkMenubutton.c: lint

	* generic/tkEntry.c: Fixed bad option table entry.

1999-04-22    <redman@scriptics.com>

	* generic/tkImgBmap.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c: Set the -translation and -encoding options
	to binary for image files. (reported by Marco Gazzetta)

1999-04-20    <redman@scriptics.com>

	* xlib/X11/Xlib.h: changed definition of Status type to use a
	typedef instead of a #define to avoid conflicting with the cygwin
	win32 headers [Bug 1804]

1999-04-15    <stanton@scriptics.com>

	* Merged 8.1 branch into the main trunk

1999-04-09    <redman@scriptics.com>

	* generic/tkWindow.c: Fixed deadlock situation when the Initialize()
	function returns without releasing the mutex.  Found while testing
	Bug 1700, during safe.test (tk).

1999-04-06    <stanton@scriptics.com>

	* generic/tkMain.c (Tk_MainEx): Changed to reset result before
	calling Tcl_EvalFile.  The ensures that error messages will be
	generated cleanly.

	* tests/winfo.test: Enabled tests that previously failed.

1999-04-05    <stanton@scriptics.com>

	* library/bgerror.tcl:
	* library/button.tcl:
	* library/clrpick.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/palette.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tk.tcl: Lots of minor performance improvements
	contributed by Jeffrey Hobbs. [Bug: 1118]

	* win/tkWinWm.c (Tk_WmCmd): Fixed bad code in tracing
	suboption. [Bug: 1519]

	* library/tkfbox.tcl: Change to restore button text after an
	action to avoid the sticky "Open" button in a save dialog.
	[Bug: 1640]

	* library/entry.tcl: Fixed so selection is returned using the
	-show character during cut and paste operations. [Bug: 1687]
	
1999-04-5     <redman@scriptics.com>

	* generic/tkInt.decls:
	* generic/tkIntXlibDecls.h:
	* generic/tkStubInit.c:
	* xlib/xgc.c:
	* xlib/X11/Xlib.h:
	* xlib/X11/Xutil.h: Added more X functions to the Win & Mac stubs
	tables.
	
1999-04-05    <stanton@scriptics.com>

	* unix/configure.in:
	* generic/tkCanvPs.c: Added configure test for pw_gecos field in
	pwd to support OS/390. [Bug: 1724]

1999-04-02    <stanton@scriptics.com>

	* tests/text.test: 
	* generic/tkText.c: Fixed handling of Unicode in text searches.
	The -count option was returning byte counts instead of character
	counts. [Bug: 1056, 1148, 1666]

1999-04-01    <redman@scriptics.com>

	* generic/tk.decls:
	* generic/tk.h:
	* generic/tkStubInit.c:
	* generic/tkWindow.c:
	* unix/Makefile.in:
	* win/makefile.vc: Tk now uses its own stub library to store
	pointers to its own stubs table.

	* doc/dde.n: (removed)
	* doc/send.n:
	* generic/tk.decls:
	* tests/winSend.test:
	* generic/tkPlatDecls.h:
	* win/tkWinSend.c:  Removed the DDE-based send and dde commands,
	they were causing Tk to lock up when any window on the system was
	not processing its message queue (more importantly, windows in Tcl
	and Tk).  The send command needs to be rewritten to prevent the
	deadlock situation (soon).  The dde command is being pushed into
	its own package and will provide almost all of the capabilities
	that send did before (using a "dde eval" command), not yet
	completed.

1999-03-31    <redman@scriptics.com>

	* win/tkWinSend.c: Modified dde/send code to work properly on
	Win95/Win98. String lengths are not returned properly by DDE, so
	NULL terminate all strings going in and ignore the string length
	coming back out.  Do not destroy handles until all necessary work
	on those handles (and child handles) is done.

1999-03-30    <stanton@scriptics.com>

	* generic/tkWindow.c (Tk_DestroyWindow): Image handlers are now
	finalized before the font subsystem since complex image handlers
	may contain references to fonts (e.g. Tix compound images).
	[Bug: 1603]

1999-03-29    <stanton@scriptics.com>

	* doc/MeasureChar.3: 
	* doc/TextLayout.3: 
	* generic/tk.decls: 
	* generic/tkCanvText.c: 
	* generic/tkEntry.c:
	* generic/tkFont.c: 
	* generic/tkListbox.c: 
	* generic/tkMessage.c: 
	* mac/tkMacFont.c: 
	* unix/tkUnixButton.c: 
	* unix/tkUnixFont.c: 
	* unix/tkUnixMenu.c: 
	* win/tkWinFont.c: 
	* win/tkWinMenu.c: Standardized text layout and font interfaces
	so they are consistent with respect to byte versus character
	oriented indices.  The layout functions all manipulate character
	oriented values while the lower level measurement functions all
	operate on byte oriented values.  This distinction was not clear
	and so the functions were being used improperly in a number of
	places.  [Bug: 1053, 747, 749, 1646]

	* generic/tk.decls: Eliminated uses of C++ STL types string and
	list from declarations.

	* generic/tkFont.c: Changes to named fonts were not being
	propagated in some cases. [Bug: 1144]
	
	* xlib/X11/Xlib.h:
	* generic/tkInt.decls: Added XParseColor to xlib stub
	tables. [Bug: 1574] 

	* doc/GetBitmap.3: 
	* generic/tkBitmap.c (BitmapInit): Eliminated use of Tk_Uid's in
	bitmaps.  Added a few CONST declarations.

1999-03-29    <redman@scriptics.com>

	* unix/configure.in:
	* unix/Makefile.in:
	* win/makefile.vc:
	* generic/tkDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkPlatDecls.h:
	* generic/tkIntXlibDecls.h: Removed stub functions. Always use the
	Tcl stubs when building with --enable-shared.
	

1999-03-26    <redman@scriptics.com>

	* generic/tkTextIndex.c:
	* tests/testIndex.test: Avoid looking past the beginning of the
	array storing data for the text widget (.t index end-2c).  Added
	test case to check for the bug.  [Bug 991]
	
	* generic/tkConsole.c: Copy static strings into a Tcl_DString
	before passing to Tcl_Eval, in case the compiler puts static
	strings into read-only memory.

1999-03-26    <suresh@scriptics.com>
	
	* unix/configure.in:
        --nameble-shared is now the default and builds Tk as a shared
        library; specify --disable-shared to build a static Tk library
        and shell.

1999-03-26    <surles@scriptics.com>

	* library/menu.tcl: Fixed bug reported by Bryan Oakley in the
	menubutton bindings.  There was a false assumption that there was
	always a menu attached to the button.  [Bug 1116] 

1999-03-26    <redman@scriptics.com>

	* unix/configure.in: Removed --enable-tcl-stub.  Linking Tk to Tcl
 	stubs is causing too many problems when linking executables like wish.
  	Until the Tk is a fully loadable extension, linking against the Tcl
 	stubs is not supported in Tk.

1999-03-19    <redman@scriptics.com>

	* generic/tkBitmap.c:
	* generic/tkCursor.c:
	* generic/tkGC.c: When creating hash tables that key off of XID
 	handles, make sure to pass TCL_ONE_WORD_KEYS.  XIDs are guaranteed
 	to be 32bit numbers, although on some 64bit systems (including 64bit
 	Solaris 7) they are packed into a 64bit value where the upper 32bits
 	are zero. The normal method of sizeof(XID)/sizeof(int) causes the
 	hash table code to assume that the XID is a pointer to an array of 
	two ints, which it is not.  Tk now supports 64bit Solaris 7.

1999-03-17    <stanton@scriptics.com>

	* win/makefile.vc: 
	* generic/tk.h: Changed to use TCL_BETA_RELEASE macro, and fixed
	so this works in rc files.
	
	* win/makefile.vc: 
	* win/makefile.bc: 
	* win/README: 
	* unix/configure.in: 
	* generic/tk.h: 
	* README: Updated version to 8.1b3.

1999-03-14    <stanton@GASPODE>

	* unix/configure.in: Added missing stub related definitions.

	* unix/Makefile.in: Install tkDecls.h in addition to tk.h.

	* generic/tkStubLib.c: Added flags to ensure we are using Tcl
	stub macros.

1999-03-11    <stanton@GASPODE>

	* generic/tkInt.decls: Added reserved slot for XSetDashes for use
	by the dash patch.

1999-03-10    <redman@scriptics.com>

	* xlib/xdraw.c:
	* xlib/X11/Xlib.h:
	* mac/tkMac.h:
	* mac/tkMacInt.h:
	* mac/tkMacPort.h:
	* mac/tkMacXStubs.c:
	* mac/tkMacAppInit.c:
	* mac/tkMacCursor.c:
	* win/makefile.vc:
	* win/tkWin.h:
	* win/tkWinInt.h:
	* win/tkWinPort.h:
	* win/winMain.c:
	* generic/tk.h:
	* generic/tkInt.h:
	* generic/tk.decls:
	* generic/tkInt.decls:
	* generic/tkDecls.h:
	* generic/tkPlatDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkStubs.c:
	* generic/tkPlatStubs.c:
	* generic/tkIntStubs.c:
	* generic/tkIntPlatStubs.c:
	* generic/tkIntXlibStubs.c:
	* generic/tkStubInit.c:
	* generic/tkStubLib.c:
	* generic/tkBind.c:
	* generic/tkCmds.c:
	* generic/tkConfig.c:
	* generic/tkConsole.c: 
	* generic/tkCursor.c:
	* generic/tkGrab.c:
	* generic/tkImgPhoto.c:
	* generic/tkMain.c:
	* generic/tkMenu.c:
	* generic/tkPointer.c:
	* generic/tkTextDisp.c:
	* generic/tkWindow.c:
	* unix/tkUnixInt.h:
	* unix/tkUnixPort.h:
	* unix/Makefile.in:
	* unix/configure.in:
	* unix/tkConfig.sh.in:
	* unix/tkUnix.c:
	* unix/tkUnix3d.c:
	* unix/tkUnixDraw.c:
	* unix/tkUnixFont.c:
	* unix/tkUnixMenubu.c: Stubs implementation for 8.1.  Tk_Main() is
	replaced with a macro which calls Tk_MainEx(). Tk can link to the Tcl
	stubs library, wish links directly to Tcl and Tk. Use
	--enable-tcl-stubs to link Tk to the Tcl stubs library (Unix), on
	by default on Windows. Exported all public functions through the
	stubs mechanism (see the *.decls files) and many of the internal
	functions. Most of the changes dealt with shifting around the
	function declarations in the header files.  Mac code may not
	compile, but it shouldn't take much work to fix this.
	
	* mac/tkMacMenu.c: Added dummy TkpMenuThreadInit for Mac to be
	consistent with Unix and Windows versions.
	
1999-03-08    <lfb@scriptics.com>

	* win/tkWinWm.c: Toplevel class no longer shared between 
	threads.
	
	* win/tkWinX.c: Multiple threads no longer share the same
	TkDisplay structure.  Required because TkDisplay stores much
	thread-specific data for a given thread.

	* win/tkWinSend.c: Moved application instance handle out
	out thread-local storage.  DDE was failing to initialize
	when the instance handles were different between threads.
	
	* win/makefile.vc: Added THREADDEFINES for building with
	threads enabled.
	
	* generic/tkMenu.c:
	* win/tkWinMenu.c:
	* unix/tkUnixMenu.c: Added TkpMenuThreadInit for initializing
	thread-specific Menu state.

1999-03-01    <redman@scriptics.com>

	* win/tkWinWm.c: 
	* win/tkWinPointer.c:
	* win/tkWinInt.h: Fix "focus -force" for Windows.  The Win32 API
	function SetForegroundWindow() does not work unless the window
	handle is a toplevel window (a Windows toplevel).  The handle
	being passed was a Tk toplevel, which is a child of the Windows
	toplevel.

1999-02-26    <redman@scriptics.com>

	* win/cat.c: Remove this file, use the one in the Tcl source directory.

	* win/makefile.vc: Remove the wishc.exe from the default targets.  Add
	a separate console-wish target to build it.  The need for a 
	console-wish will go away soon, so we don't want to encourage its
	use.

1999-02-25    <redman@scriptics.com>

	* win/tkWinWm.c: Properly initialize the tsdPtr->firstWindow field.
	
	* win/cat.c: Code for cat32.exe, copied from the Tcl sources. Required
	in order to run the test suite from the makefile

	* win/winMain.c: Add main() for a console-based wishc.exe, which meant
	adding code to disable the call to Tk_ConsoleInit().
	
	* generic/tkConsole.c: Check the standard handles before creating the
	new standard channels.	This allows a windows app that has stdin,
	stdout, or stderr to correctly connect to them.
	
	* generic/tkMain.c: Add a proper check for the interactive mode, since
	the standard channels may actually be connected in windows mode or
	even in the console-based wish.
	
	* win/makefile.vc: Add targets for wishc.exe (console-based wish) and
	cat32.exe (for testing). Fix the test suite target so it can be run
	from the makefile (which can happen since the standard handles have
	been fixed).

1999-02-12    <lfb@scriptics.com>

	* generic/tkMenuButton.h:
	* generic/tkMenuButton.c:
	* mac/tkMacMenubutton.c:
	* mac/tkMacDefault.h
	* unix/tkUnixMenubu.c: Eliminated Tk_Uids used by -state option.
	* unix/tkUnixDefault.h
	* win/tkWinDefault.h
	

	* generic/tk.h:
	* generic/tkScale.h:
	* generic/tkScale.c:
	* generic/tkWindow.c:
	* unix/tkUnixScale.c:	
	* unix/tkUnixDefault.h:
	* unix/tkWinDefault.h:
	* mac/tkMacDefault.h:  Objectified scale widget.

	* win/tkWinX.c: Removed Thread-specific data from process
	initialization code that was stopping the Tk Dll from 
	loading.

1999-02-11    <stanton@GASPODE>

	* README:
	* generic/tk.h: 
	* unix/configure.in:
	* win/README:
	* win/makefile.bc:
	* win/makefile.vc: Updated version to 8.1b2.
	
	* unix/tkUnixSend.c: Fixed one more Tcl_*ObjVar instance.
	
1999-02-04    <stanton@GASPODE>

	* Various cleanup related to the Tcl_Eval and Tcl_ObjSetVar
	changes in Tcl.
	
	INTEGRATED PATCHES FROM 8.0.5b2: 
	
	* win/tkWinMenu.c (TkpDestroyMenu): Changed so modalMenuPtr is
	cleared when it is being destroyed.

	* generic/tkImgPhoto.c: Changed so color tables are freed
	immediately instead of being delayed.  This ensures that color
	tables are properly disposed at process exit.

	* library/prolog.ps: Changed string that determines font height to
	include European character with an umlaut.

	* generic/tkImgBmap.c (ImgBmapConfigureInstance): If an image
	mask changed but ended up with the same XID, the GC failed to be
	updated and so the new mask was not used. [Bug: 970]

	* generic/tkFocus.c (SetFocus): Changed so focus window is always
	set if -force is specified.  This fixes the problem on Windows
	where Tk does not activate the window if it already has focus.

	* generic/tkConsole.c: Fixed so errors in console eval are
	reported properly.  Eliminated duplicate result messages. [Bug: 973]

	* win/tkWinWm.c: Changed so windows that aren't resizable don't
	have resize handles and the zoom box is disabled.

	* win/tkWinInt.h:
	* win/tkWinPointer.c: Changed to cancel the mouse timer when a
	user initiated move/resize loop begins.

	* unix/configure.in: TK_LD_SEARCH_FLAGS was set incorrectly if
	SHLIB_LD_LIBS='${LIBS}', and shared linking is performed through
	the C compiler. Systems affected are Linux, MP-RAS and NEXTSTEP,
	but also with gcc on many more systems. [Bug: 908]

	* win/makefile.vc: First stab at install target.  Fixed quoting so
	paths with spaces work.
	
	* tests/main.test:
	* tests/unixWm.test: Better cleanup of temporary files.
	
	* mac/tkMacAppInit.c:
	* generic/tkTest.c:
	* generic/tkAppInit.c:
	* win/winMain.c: Changed some EXTERN declarations to extern
	since they are not defining exported interfaces.  This avoids
	generating useless declspec() attributes and makes the windows
	makefile simpler.

	* library/menu.tcl (tkMenuFind): Changed so keyboard shortcuts
	will only be found in the current toplevel.  Previously, they
	might be found in menus attached to other toplevels that might not
	even be mapped. [Bug: 924]

	* generic/tkCanvLine.c: Changed to treat zero width lines like
	they have width 1 for purposes of selection. [Bug: 925]

	* win/tkWinFont.c (Tk_MeasureChars): Added a workaround for a bug
	in GetTextExtentExPoint on Win NT 4.0/Japanese. [Bug: 1006]

	* unix/tkUnixSend.c (Tk_SetAppName): Fixed uninitialized memory
	access bug. [Bug: 919]

1999-1-28    <stanton@GASPODE>

	* generic/tkGrid.c: Fixed bug in "grid forget" that failed to cancel
	pending idle handlers, resulting in a crash in a few odd cases.

1999-01-06  <lfb@JUSTICE>

	* generic/tk.h, generic/tkGet.c, generic/tkConfig.c, 
	* generic/tkOldConfig.c, generic/tkEntry.c, generic/tkMenubutton.c, 
	* generic/tkMenubutton.h, generic/tkScale.c, generic/tkScale.h, 
	* generic/tkTextDisplay.c, generic/tkText.c, unix/tkUnixMenubu.c, 
	* unix/tkUnixScale.c, mac/tkMacMenu.c, mac/tkMacMenubutton.c, 
	
	Removed global Tk_Uids dealing with "-state" configuration option
	and added new TK_CONFIG_STATE configSpec that doesn't use 
	Tk_Uids.

1998-12-11    === Tk 8.1b1 Release ===
	
1998-12-11    <stanton@GASPODE>

	* generic/tkMain.c (Tk_Main): Fixed improper command line encoding
	handling. 

1998-12-08    <stanton@GASPODE>

	* tkMacMenu.c, tkUnixMenu.c, tkWinMenu.c, tkMenuDraw.c, tkMenu.h,
	* tkMenu.c: Backed out the previous fix for bug 620 and
	eliminated a bunch of code that created unnecessary objects.
	Changed back to using internal types instead of objects for many
	configuration options.	There are many more fixes like this that
	could be made, but some require a little restructuring of the
	code. In any case the leaks are fixed and there is a lot less
	allocation happening. [Bug: 620]
	
2000-03-21  Syd Polk  <spolk@cygnus.com>

	* configure.in: Compare to cygwin, not cygwin32.
	* configure: Regenerate.

1999-05-24  Syd Polk  <spolk@cygnus.com>

	* generic/tkArgv.c: Updated version string.

1999-04-22  Syd Polk  <spolk@cygnus.com>

	* unix/Makefile.in: Don't install tk.h for install-libraries.

1999-03-19  Khamis Abuelkomboz  <khamis@cygnus.com>
	
	* library/tkfbox.tcl (tkFDialog_OkCmd): Bug fix for double-click on
	a directory when multiple-mode is turned on, double-clicking a
	directory didn't switch to that directory.

1999-03-19  Khamis Abuelkomboz  <khamis@cygnus.com>

	* win/tkWinDialog.c (GetFileName): set the multi flag to the boolean
	value it was given to turn multi-selection on/off.

	* library/tkfbox.tcl (tkFDialog): mask list of selected files using the
	list command only when the string isn't empty to avoid getting "{}"
	in the entry box.

1999-03-19  Khamis Abuelkomboz  <khamis@cygnus.com>

	* library/tkfbox.tcl (tkFDialog): Corrected reference to not valid
 	variable name.

	* win/tkWinDialog.c (GetFileName): set the multi flag to the boolean
        value it was given to turn multi-selection on/off.

1999-03-18  Syd Polk  <spolk@cygnus.com>

	* library/tkfbox.txl (tkFDialog): Fix a reference to an unknown
	variable $text.

1999-03-18  Khamis Abuelkomboz  <khamis@cygnus.com>

	* win/tkWinDialog.c (GetFileName): When only one file is selected and
	multi selection is enabled, add the file using tcl_AppendElement to the
	result to get a list of files (here with only one file). This makes
        the functionality consistent to  the case when multiple files are
        selected. This has produced a bug when only one file is selected that
	contains spaces.

	* library/tkfbox.tcl (tkFDialog): mask a file containing spaces using
	the list command when -multipl flag is set to yes.
	(tkFDialog_ListBrowse): likewise.

1999-03-03  Syd Polk  <spolk@cygnus.com>

	* generic/tkText.c (TextSearchCmd): Was incorrectly returning
	number of bytes instead of number of characters in search subcommand.

1999-03-04  Syd Polk  <spolk@cygnus.com>

	* win/tkWinMenu.c: Fixed compile error introduced by merge
	of 1999-03-02.

1999-02-28  Ian Roxborough  <irox@cygnus.com>

	* win/tkWin3d(Tk_3DHorizontalBevel,Tk_3DVerticalBevel):
	Draw sunken 3D effect the same as Window95/98/NT.
	* win/tkWinButton: Decrease this minimum button high
	for a better Windowz look and feel.
	* win/tkWinDefault.h: Increase default button y padding.

1999-02-22  Syd Polk  <spolk@cygnus.com>

	* win/configure.in: Fix TK_LIB_FULL_PATH for cygwin build.
	* win/configure: Regenerate.

1999-02-18  Syd Polk  <spolk@cygnus.com>

	* win/configure.in: Set TK_SRC_DIR and export it.
	Set TK_LIB_FULL_PATH and export it.
	* win/configure: Regenerate.

1999-02-09  Syd Polk  <spolk@cygnus.com>

	* unix/configure.in: Export TK_LIB_FULL_PATH so that dependency
	tracking can be done.
	Use TCL_LIB_FULL_PATH to track dependencies.
	* unix/configure: Regenerate.
	* unix/tkConfig.sh.in: Export TK_LIB_FULL_PATH so that dependecy
	tracking can be done.
	* unix/Makefile.in: Add dependency for TCL_LIB_FULL_PATH.

1998-12-31  Syd Polk  <spolk@cygnus.com>

        * generic/tkFont.c (Tk_UnderlineTextLayout):
	Don't draw an underline if underline value is
	-1.

1998-12-30  Syd Polk  <spolk@cygnus.com>

	* generic/tkFont.c (Tk_UnderlineTextLayout):
	Tk_CharBBox needs a byte offset, not a character
	offset.

1998-12-17  Syd Polk  <spolk@cygnus.com>

        * win/tkWinMenu.c: (TkWinMenuHandleEvent): WM_MENUCHAR
        needs to index characters, not bytes, when handling the
        underline character.

1998-12-11  Syd Polk  <spolk@cygnus.com>

	* generic/tkMain.c (Tk_Main): All arguments except the filename
	on the command-line were not being translated to UTF.

1998-12-10  Ian Roxborough  <irox@cygnus.com>

	* win/tkWinDialog.c (GetFileName): Increased the buffer size in the
	file select dialog so that there is less change of it filling up
	if the user selects a lot of files.

1998-12-04  Syd Polk  <spolk@cygnus.com>

	* win/tkWinClipboard.c: The clipboard was not translating to
	and from the Windows character set.

1998-12-03  Ian Roxborough  <irox@cygnus.com>

	* win/tkWinInit.c: Merged in changes from WishCon.
	* win/tkMain.c: Merged in changes from WishCon.

1998-11-18  Syd Polk  <spolk@cygnus.com>
	* generic/tkMenu.c (ConfigureMenuCloneEntries): The parameter for
	the configure command when reconfiguring entries for a clone menu
	should have been "-menu", not "menu".

1998-11-19  Ben Elliston  <bje@cygnus.com>

	* win/tkWinWm.c: Local grabs did not exclude menus or the caption
	bar. `wm frame' would crash if the window had not been mapped yet.
	Patch obtained from the Scriptics CVS repository.

	* win/tkWinWindow.c: Reduce message traffic by setting
	WS_EX_NOPARENTNOTIFY on TkChild windows. Patch obtained from the
	Scriptics CVS repository.

1998-11-13  Khamis Abuelkomboz  <khamis@cygnus.com>

	* generic/tkMenu.c (MenuWidgetObjCmd): added patch for selection
	problem. Disabled menu entries remain disabled.
	(DestroyMenuEntry): added patch for memory leak.

1998-11-11  Syd Polk  <spolk@cygnus.com>

	* win/tkWinMenu.c: Merged from latest tcl8.1 source.

1998-11-06  Ian Roxborough  <irox@cygnus.com>

	* win/tkWinDialog.c (GetFileName): Add support for --multiple to
	tk_getOpenFile.

1998-11-06  Syd Polk  <spolk@cygnus.com>

	* win/tkWinMenu.c (GetEntryText): Fixed menubars and system 
	menu character set problems.
	* win/tkWinWm.c: Fixed title bar text character set problems.

1998-10-28  Syd Polk  <spolk@cygnus.com>

	* win/Makefile.in: Remove prolog.ps from install

1998-10-26  Syd Polk  <spolk@cygnus.com>

	* win/Makefile.in: Change tcl directory.
	* win/configure.in: XINCLUDES needs be generated correctly.
	* win/configure: Regenerated.

1998-10-23  Ben Elliston  <bje@cygnus.com>

	* generic/tkFont.c (Tk_UnderlineChars): Count multibyte characters
	correctly when underlining. Contributed by Scott Stanton
	<stanton@scriptics.com>.

1998-10-20  Syd Polk  <spolk@cygnus.com>

	* unix/configure.in: Work with tcl8.1 directory name
	* unix/configure: Regenerated
	
1998-10-04  Syd Polk  <spolk@cygnus.com>

	* win/Makefile.in: Somehow this ended up on the main branch.

1998-10-14  Syd Polk  <spolk@cygnus.com>

	* win/Makefile.in configure.in: More work for tk 8.1 build.
	* win/configure: Regenerated
	* win/tkWinDialog.c: Added dummy -multiple option. irox will re-implement
	this soon.

1998-09-29  Syd Polk  <spolk@cygnus.com>

	* win/configure.in: Generate the correct version number
	* win/configure: Regenerated.
	* win/Makefile.in: Now compiles for Visual C++.
	* win/tkWinFont.c win/TkWinInt.h win/TkWinWm.c: Removed changing
	font map when system changes. 8.1 is eventually supposed to support
	this and the font package changed dramatically. The changes were
	not easy to bring forward, so we will have to do something if
	Tk 8.1 does not support this.

1998-09-29  Syd Polk  <spolk@cygnus.com>

	* win/configure.in: Merged from devo
	* win/configure: Regenerated.

1998-09-28  Syd Polk  <spolk@cygnus.com>

	* win/Makefile.in: Fixes for OBJEXT; removed hard-coded 80
	references; added new tk files for 8.1.

Wed Aug 19 17:48:00 PDT 1998  Syd Polk  <spolk@cygnus.com>

	* Continued 8.1 integration

Mon Jul  6 18:13:02 1998  Martin M. Hunt  <hunt@cygnus.com>

	* win/Makefile.in: Remove bad line with just "mv" on it.

Mon Jul  6 15:53:35 1998  Ian Roxborough  <irox@cygnus.com>
	* win/Makefile.in: Don't set lflags or lcommon if you're not
	setting OBJEXT to 'obj', (i.e. for MSVC).

Sat Jul  4 16:21:25 1998  Ian Roxborough  <irox@cygnus.com>
	* win/Makefile.in: Don't make dumpext.exe unless you're using MSVC
	and setting OBJEXT = obj.

1998-07-03  Ben Elliston  <bje@cygnus.com>

	Patches from Ian Roxborough <irox@cygnus.com>.
	* win/configure.in: Add AC_OBJEXT macro invocation.

	* win/configure: Regenerate.

	* win/Makefile.in: Don't assume object files end in `.o'.
	
Wed Jul  1 00:11:02 1998  Khamis Abuelkomboz  <khamis@cygnus.com>

	* unix/tkUnixDefault.h (DEF_TEXT_TAB_SIZE): new macro to define
	the default tab size "8".
	
	* win/tkWinDefault.h (DEF_TEXT_TAB_SIZE): new macro to define the
	default tab size "8".

	* mac/tkMacDefault.h (DEF_TEXT_TAB_SIZE): new macro to define the
	default tab size "8".

	* generic/tkTextDisp.c (NextTabStop): Added the text widget pointer
	as an argument for this function to read the set tab-width for
	the default tabulator behavior. Default is 8.

	* generic/tkText.c: (configSpecs) Added "-tabsize" to the option
 	command list of	the text widget. It defines the width of the
	default tabulator, default 8.

	* generic/tkText.h: added a new structur member to TkText "tabsize",
	it stores the tab width (default 8). "-tabs" doesn't support
	normal text tabulator behaviar, so we can't use it in SN.

Thu Jun 18 10:27:00 1998  Syd Polk  <spolk@cygnus.com>
	
	* Removed all of the files in Tk 8.1a2 not in Tk 8.0p2. They
	were added when the import was done.

Fri Jun 12 11:48:26 1998  Mumit Khan  <khan@xraylith.wisc.edu>

	* configure.in (*-*-mingw32*): Support.
	* win/Makefile.in (DLL_LDLIBS, DLL_LDFLAGS): New variables.
	(tkcyg.def): Ignore errors.
	(plugin.def): Likewise.
	($(TKDLL),$(TKPLUGINDLL)): Cleanup DLL build flags and use
	DLL_LDLIBS and DLL_LDFLAGS.
	* win/configure.in (DLL_LDLIBS, DLL_LDFLAGS): Define and substitute.
	(TK_PATCH_LEVEL): Bump to p2.
	* win/tkWinPort.h (TK_READ_DATA_PENDING): Define for Mingw32.
	(timezone,timeval,gettimeofday): Don't define/declare for Mingw32.
	* win/tkWinX.c (GetCurrentTime): Define as GetTickCount if
	__MINGW32__ as well.
	* win/configure: Rebuild.

Fri May 29 17:12:29 1998  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in (X11_INCLUDE_INSTALL_DIR): New variable.
	(install-libraries): Install X11 header files in
	X11_INCLUDE_INSTALL_DIR.
	(install-minimal): Don't create INCLUDE_INSTALL_DIR.
	* win/configure.in: Call AC_CANONICAL_HOST.
	* win/configure: Rebuild.

Wed May 27 17:00:35 1998  Ian Lance Taylor  <ian@cygnus.com>

	* library/tkfbox.tcl (tkFDialog): Save the old multiple setting,
	and recreate the dialog if it changes.

Thu Apr 30 18:10:15 1998  Geoffrey Noer  <noer@cygnus.com>

	* win/Makefile.in: invoke gcc instead of ld when producing
	dlls.  Pass the linker options down via args to -Wl options.

Sun Apr 26 15:45:18 1998  Khamis Abuelkomboz  <khamis@mxbig.multix.de>

	* generic/tkCanvBmap.c (tkCreateBitmap): renamed from "CreateBitmap"
	to avoid conflicts with the already defined MSVC procedure.

Thu Apr 23 10:09:29 1998  Tom Tromey  <tromey@cygnus.com>

	* library/tkfbox.tcl (tkFDialog_Config): Use lindex, not join, to
	extract list item.
	(tkFDialog_Config): Recognize -choosedir option.
	(tkFDialog_OkCmd): If -choosedir set, then don't special-case
	directories.
	(tkFDialog_VerifyFileName): Handle -choosedir.
	(tkFDialog_ListBrowse): Likewise.

Thu Apr 16 17:30:46 1998  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinButton.c (WinButton): Add pixFlags field.
	(TkpCreateButton): Initialize new pixFlags field.
	(TkpDestroyButton): Clear pixmap field if we free the pixmap.
	(TkpRealDisplayButton): Don't free the pixmap just because we're
	unmapping the window.  Check pixFlags field to see if we can use
	the cached pixmap.  Set pixFlag field if we cache the pixmap.
	* generic/tkButton.c (TkButtonWorldChanged): Remove Cygnus local
	patch; once again check whether the button is mapped before
	scheduling a call to TkpDisplayButton.
	(ButtonVarProc): Likewise.

Thu Apr 16 15:59:55 MEST 1998 Khamis Abuelkomboz <khamis@multix.de>
	* library/tkfbox.tcl
	-One COMMENT: I have never seen so bad tcl/source code as how this 
	 stuped tk/filedialog is implemented!!!!!!!!!!!!!

	(tkIconList_Select): Include the fact that by multi-selection a file 
		could contain blanks, so that the file is added as a list 
		element.
	(tkFDialog): When the dialog is not new created (withdrawn) don't 
		center it again
		-Define Tracer before calling the dialog and immediatly remove
		 it after selection.
		-tk dialog box doesn't use dynamic array names, so it's
		 not possible to use more than one dialog box at the same
		 time. Other dialogs must be deleted!
	(tkFDialog_SetPath): Accept the fact that the variable could be bound
		on a already deleted widget (trace).
		-No tracer here.
	(tkFDialog_Config): "glob" command returns a list of items, so we must
		join the result, this was bugy when a file has contained blanks.
	(tkFDialog_ActivateEnt): We can't trim a list.
	(tkFDialog_OkCmd): Join file name only by single selection.
	(tkFDialog_ListInvoke): Differ between single and multi selection by
		joining files.
		-return a list of files by multi-selection and the file itself
		 by single-selection.

Tue Apr 14 15:01:10 1998  Ian Lance Taylor  <ian@cygnus.com>

	* generic/tkText.c (TextBlinkProc): Remove test of TkTextCharBbox,
	since it is a difference from standard releases, and it will never
	change what happens.

Mon Apr 13 17:55:13 1998  Ian Lance Taylor  <ian@cygnus.com>

	* compat/memmove.c: Remove.

Thu Apr  9 15:00:47 1998  Martin M. Hunt  <hunt@cygnus.com>

	* library/msgbox.tcl (tkMessageBox): When a default button
	is supplied, simply set the focus on it, don't bind <Return>.
	For all buttons, bind <Return> for them so the button command
	is invoked.

Tue Apr  7 20:32:40 1998  Ian Lance Taylor  <ian@cygnus.com>

	* tests/msgbox.test: Update unknown option message for -modal
	option.

Fri Mar 27 15:18:30 1998  Jeff Holcomb  <jeffh@cygnus.com>

	* win/tkWinX.c: Added temporary define for MNC_CLOSE.

Wed Mar 11 13:48:31 1998  Tom Tromey  <tromey@cygnus.com>

	* library/entry.tcl: Only bind <Insert> when not on Windows.

Sat Mar 21 21:18:06 1998  Elena Zannoni  <ezannoni@kwikemart.cygnus.com>

	Merged changes from Foundry (list follows in reverse chronological order)

        - Tom Tromey  <tromey@cygnus.com>
	* win/tkWinWm.c (InitWm): Look for "tk" icon first in
	application's resources and then in Tk DLL's.
	* generic/tkButton.c (TkButtonWorldChanged): Don't check to see if
	button is unmapped before scheduling a redraw.
	* win/tkWinWm.c (Tk_WmCmd): In "frame" case, make window exist if
	it doesn't already.
	* generic/tkButton.c (ButtonVarProc): Don't check to see if button
	is unmapped before scheduling a redraw.
	* win/tkWinButton.c (TkpRealDisplayButton): Destroy backing pixmap
	if window is unmapped.
	* win/tkWinWm.c (EX_TRANSIENT_STYLE): Define as 0.
	* win/tkWinX.c (Tk_TranslateWinEvent): Handle WM_MENUCHAR.
	(GenerateXEvent): Likewise.
	* win/tkWinWm.c (UpdateWrapper): Turn off maximize box and sizebox
	for non-resizable windows.
	* win/tkWinDialog.c (Tk_MessageBoxCmd): Don't pass
	MB_SETFOREGROUND for "-modal system".

        -  Ian Lance Taylor  <ian@cygnus.com>
	* win/Makefile.in ($(TKDLL)): Don't generate relocs for debugging
	information.
	* win/tkWinFont.c (Tk_MeasureChars): Free the partials array.
	* win/tkWinFont.c (Tk_MeasureChars): Rearrange to always use sizes
	from partials array, rather than size.cx.

        -  Tom Tromey  <tromey@cygnus.com>
	* win/tkWinMenu.c (TkWinHandleMenuEvent): Don't use height element
	of indicatorDimensions when computing width.
	* win/tkWinDialog.c: Reverted previous change.  It turns out that
	with the change, if the user selects too many files, the list will
	be truncated in the middle but no error message will be returned.
	This makes it impossible to detect failures.
	* win/tkWinDialog.c (ParseFileDlgArgs): If -multiple passed, don't
	require files to exist.  This is a hack to work around a bug in
	the common dialog.
	(CYG_MAX_PATH): New define.
	(_OpenFileData): Use CYG_MAX_PATH.
	(GetFileName): Likewise.
	* generic/tkTextDisp.c (DisplayDLine): Display cursor for disabled
	widgets on Windows.

        -  Ian Lance Taylor  <ian@cygnus.com>
	* win/tkWinFont.c (WinFont): Remove widths field.
	(Tk_MeasureChars): Rewrite to use GetTextExtentExPoint, and not
	assume that Windows doesn't do kerning, since in reality it does
	do kerning.
	(AllocFont): Don't initialize widths field.

        -  Tom Tromey  <tromey@cygnus.com>
	* library/text.tcl (tkTextButton1): Unconditionally set the
	focus.

        -  Ian Lance Taylor  <ian@cygnus.com>
	* win/tkWinDialog.c (Tk_MessageBoxCmd): If -modal system, pass
	MB_SETFOREGROUND.  May or may not be useless.
	* generic/tkFocus.c (SetFocus): If force, then don't just return
	even if the desired window is already the focus window.
	* win/tkWinPointer.c (TkpChangeFocus): Call XSetInputFocus even if
	force.
	* win/tkWinWm.c (EX_TRANSIENT_STYLE): Remove WS_EX_TOOLWINDOW.

Mon Jan 12 15:45:03 1997  Syd Polk <spolk@cygnus.com>

	* library/tkfbox.tcl (tk_getOpenFile): tk_getOpenFile would complain
	and behave incorrectly if the -initialdir argument had a space
	in it.

Wed Dec 31 12:27:25 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in (install-libraries): Install the X11 header
	files as well as tk.h.

Tue Dec 23 16:31:07 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in ($(TKDLL)): Don't generate relocs for debugging
	information.

Mon Nov 17 18:07:12 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinButton.c (TkpCreateButton): Initialize pixmap field.
	(TkpDestroyButton): Free pixmap field.
	(TkpDisplayButton): Entire function moved into
	TkpRealDisplayButton.
	(TkpRealDisplayButton): New static function, from old
	TkpDisplayButton.
	(TkpComputeButtonGeometry): Discard any saved pixmap.
	(ButtonProc): Call TkpRealDisplayButton, not TkpDisplayButton.

Fri Nov 14 12:24:04 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinMenu.c (TkpDestroyMenu): Remove the menu handle from
	winMenuTable.  Clear modalMenuPtr if we're destroying it.
	(TkWinHandleMenuEvent): Don't treat WM_SYSCOMMAND like
	WM_COMMAND.

	* win/tkWinDialog.c (Tk_MessageBoxCmd): If -modal task, and
	-parent not used, pass hWnd as NULL to MessageBox.

Tue Nov 11 20:07:04 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinMenu.c (TkWinHandleMenuEvent): If TkPreprocessMenu
	returns an error, call Tcl_BackgroundError.

Fri Nov  7 15:52:23 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinDialog.c (Tk_MessageBoxCmd): Accept -modal option.
	* library/msgbox.tcl (tkMessageBox): Accept and ignore -modal
	option.

Tue Oct 28 17:51:06 1997  Martin M. Hunt  <hunt@cygnus.com>

	* generic/tkText.c: Patch text.txt from the net. Fixes
	Win95 selection bug.

	* library/dialog.tcl (tk_dialog): Two fixes from the net for
	Windows 95 dialogs. Patch "dialog.txt" from "Robert Embleton" 
	<embleton@crystal.cirrus.com>

Tue Oct 28 16:36:11 1997  Ian Lance Taylor  <ian@cygnus.com>

	* Makefile.in (install-minimal): New target.
	* win/Makefile.in (install-minimal): New target.

Thu Oct 23 12:59:18 1997  Tom Tromey  <tromey@cygnus.com>

	* generic/tkScale.c (ConfigureScale): When setting scale value,
	don't cause scale to invoke command.

Fri Oct 10 19:41:57 1997  Tom Tromey  <tromey@cygnus.com>

	* xlib/X11/Xlib.h: On Windows, use a typdef for Status.

	* win/tkWinPort.h: Declare struct timeval.

Wed Oct  8 18:33:41 1997  Jeffrey A Law  (law@cygnus.com)

	* generic/tkText.c: Avoid ANSI-C code.

Tue Oct  7 10:32:01 1997  Tom Tromey  <tromey@cygnus.com>

	* library/button.tcl: Bind <Return> to invoke buttons on Windows.

Thu Oct  2 17:05:14 1997  Ian Lance Taylor  <ian@cygnus.com>

	* generic/tkColor.c (struct TkGCList): Define.
	(Tk_GetColor): Initialize gcList element.
	(Tk_GetColorByValue): Likewise.
	(TkMapOverColors): New function.
	(TkRegisterColorGC, TkDeregisterColorGC): New functions.
	(TkColorChanged): New function.
	* generic/tkColor.h (TkGCList): Define typedef.
	(TkColor): Add gcList field.
	(TkMapOverColors, TkColorChanged): Declare.
	* generic/tkGC.c: Include tkInt.h.
	(TkGC): Add foreground and background fields.
	(ValueKey): Add foreground and background fields.
	(Tk_GetGCColor): Rename from Tk_GetGC.  Add foreground and
	background parameters.  Register the GC with the colors.
	(Tk_GetGC): New function which just calls Tk_GetGCColor.
	(Tk_FreeGC): Deregister colors.
	* generic/tk.h (Tk_GetGCColor): Declare.
	* generic/tkInt.h (TkRegisterColorGC): Declare.
	(TkDeregisterColorGC): Declare.
	* win/tkWinColor.c (ChangeColor): New static function.
	(TkWinSysColorChange): New function.
	* win/tkWinWm.c	(WmProc): Handle WM_SYSCOLORCHANGE.
	* win/tkWinInt.h (TkWinSysColorChange): Declare.
	* generic/tk3d.c: Change some calls to Tk_GetGC to call
	Tk_GetGCColor instead.
	* generic/tkButton.c: Likewise.
	* generic/tkCanvArc.c: Likewise.
	* generic/tkCanvBmap.c: Likewise.
	* generic/tkCanvLine.c: Likewise.
	* generic/tkCanvPoly.c: Likewise.
	* generic/tkCanvText.c: Likewise.
	* generic/tkCanvas.c: Likewise.
	* generic/tkEntry.c: Likewise.
	* generic/tkImgBmap.c: Likewise.
	* generic/tkImgPhoto.c: Likewise.
	* generic/tkListbox.c: Likewise.
	* generic/tkMenuDraw.c: Likewise.
	* generic/tkMenuButton.c: Likewise.
	* generic/tkMessage.c: Likewise.
	* generic/tkRectOval.c: Likewise.
	* generic/tkScale.c: Likewise.
	* generic/tkTextDisp.c: Likewise.

Tue Sep 30 17:13:16 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinPointer.c (TkWinCancelMouseTimer): New function.
	* win/tkWinWm.c (WmProc): Call it in WM_ENTERSIZEMOVE case.

Mon Sep 15 16:29:16 PDT 1997 Khamis Abuelkomboz <khamis@cygnus.com>
	generic/tkText.[ch]
	Added a new functionality for the editor '-synccommand'. When it es
	not empty, this command is called, when ever the contents in the
	editor is changed (insert, delete). The function is called with the
	same parameters how it called for the editor.
	This functionality is used in the new GUI for SN to be able to open
	more than one editor with the same file (like emacs multiple buffers).

Wed Sep 10 12:56:43 1997  Ian Lance Taylor  <ian@cygnus.com>

	* generic/tkImgPhoto.c (FreeColorTable): Add force parameter.
	Change all callers.
	(DisposeInstance): Force FreeColorTable to free the color table
	immediately, in case we are being called from TkDeleteAllImages
	when Tk is exiting.

	* win/tkWinMenu.c (TkWinHandleMenuEvent): If TkInvokeMenu returns
	an error, call Tcl_BackgroundError.

	* win/Makefile.in (install-libraries): Don't try to install *.gif
	or *.xbm.

Mon Sep  8 17:13:49 MET DST 1997 Zsolt Koppany <zkoppany@multix.de>
	unix/tkUnixEvent.c
	Deleted the second unnecessary call of XOpenDisplay().

Thu Sep  4 20:07:23 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinFont.c (nonClientMap): New static array.
	(TkpGetFontFromAttributes): If the font is in a magic windows-*
	family, use SystemParametersInfo to get the attributes.
	(TkWinNCMetricsChanged): New function.
	(FontChanged): New static function.
	* win/tkWinInt.h (TkWinNCMetricsChanged): Declare.
	* generic/tkFont.c (TkUpdateFonts): New function.
	* generic/tkFont.h (TkUpdateFonts): Declare.
	* win/tkWinWm.c (WmProc): Handle WM_SETTINGCHANGE with a wParam
	value of SPI_SETNONCLIENTMETRICS.

Thu Sep  4 11:34:20 1997  Martin M. Hunt  <hunt@cygnus.com>

	* library/palette.tcl (tkRecolorTree): If color isn't
	set don't try to apply it.

	* library/menu.tcl: Apply patch "menu2.txt" from patches
	archive.

Fri Aug 29 11:27:17 1997  Tom Tromey  <tromey@cygnus.com>

	* library/menu.tcl (tk_popup): Use Tcl syntax for call to
	tk_menuSetFocus.

Thu Aug 28 15:25:31 MET DST 1997 Zsolt Koppany <zkoppany@multix.de>
	* generic/tkImgGIF.c
	Memory bug fix.

Thu Aug 28 13:36:30 1997  Ian Lance Taylor  <ian@cygnus.com>

	* testsuite/tk.tests/tk-test.exp: Permit capital letters in test
	case names.  Try better error string handling.

	* generic/tkInitScript.h (initScript): Don't call pwd in a safe
	interpreter.

	* library/tkfbox.tcl (tkFDialog_VerifyFileName): Only add file to
	selectFile using lappend if -multiple.
	* tests/filebox.tcl: Set the expected unknown options based on the
	command and mode.

Sun Aug 24 21:40:30 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in ($(TKDLL)): Set base address to 0x66300000.

Mon Aug 18 18:13:00 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinDialog.c (GetFileName): Handle the case of a single
	file when OFN_ALLOWMULTISELECT is set.

Fri Aug 15 19:26:39 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinInit.c (initScript): Don't append share to [info
	library] (revert patch of Aug 7).

Thu Aug 14 09:29:45 1997  Tom Tromey  <tromey@sanguine.cygnus.com>

	* library/dialog.tcl (tk_dialog): Run update after setting
	geometry.  From the net.

Wed Aug 13 12:28:08 1997  Tom Tromey  <tromey@sanguine.cygnus.com>

	* library/tkfbox.tcl (tkFDialog_VerifyFileName): Use fname and not
	contents of entry to compute flat, path, and file.

Tue Aug 12 18:02:15 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/rc/cygnus.ico: Change color to match other Cygnus designs.

Tue Aug 12 17:37:36 MET DST 1997 Zsolt Koppany <zkoppany@multix.de>

	* unix/tkUnixWm.c
	  Memory leak bug fixes.

	* generic/tkText.c
	  TkTextRedrawRegion() should be called only if TkTextCharBbox()
	  does not return -1, because in that case x,y and h variables
	  will not be set.

Mon Aug 11 16:58:08 1997  Ian Lance Taylor  <ian@cygnus.com>

	* configure.in: Call AC_CANONICAL_HOST.  Check host, not target,
	for cygwin32.
	* configure: Rebuild.

	* win/rc/cygnus.ico: New file.
	* win/rc/tk.rc: Replace tk.ico with cygnus.ico.

Mon Aug 11 11:14:31 1997  Martin M. Hunt  <hunt@cygnus.com>

	* generic/tk.h, generic/tkImage.c, generic/tkImgBmap.c,
  	generic/tkImgGIF.c, generic/tkImgPhoto.c, generic/tkTest.c, 
	generic/tkWindow.c, library/tkfbox.tcl,	tests/imgPhoto.test, 
	doc/photo.n: Two patches from Jan.Nijtmans@cmg.nl. Fixes 
	numerous image problems including GIF transparency.

Fri Aug  8 21:14:55 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinPointer.c (TkpChangeFocus): If force is set, call
	SetForegroundWindow.

Thu Aug  7 12:55:50 1997  Ian Lance Taylor  <ian@cygnus.com>

	* generic/tkFrame.c (mapFrameWindow): New static variable.
	(mapFrameFrame): New static variable.
	(MapFrame): Set new variables.
	(TkInstallFrameMenu): Use new variables.

	* win/tkWinInit.c (initScript): Look under share.

Wed Aug  6 23:47:01 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in: Update for Tk 8.0.
	* win/configure.in: Likewise.
	* win/configure: Rebuild.
	* win/tkWinInt.h (TkFontAttributes): Don't use typedef if
	__GNUC__.
	* win/tkWinPort.h (strnicmp, stricmp): Define if __CYGWIN32__.
	(strncasecmp, strcasecmp): Don't define if __CYGWIN32__.

Tue Aug  5 14:00:53 1997  Tom Tromey  <tromey@cygnus.com>

	* tests/all: Preserved local changes.
	* tests/defs: Preserved local changes.

Fri Jul 25 12:42:54 1997  Stephen Peters  <speters@cygnus.com>

	* win/tkWinDialog.c (GetFileName, ParseFileDlgArgs): Changes to
	  let tk_getOpenFile and tk_getSaveFile deal with multi-file
	  selections on Windows.
	* doc/getOpenFile.n: Add documentation for `-multiple' option.

Thu Jul 24 13:12:02 1997  Stephen Peters  <speters@cygnus.com>

	* library/tkfbox.tcl: Changes to let tk_getOpenFile take a
	  `-multiple yes' argument and handle multi-file selections.

Tue Jul 22 12:40:50 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in (.c.o): Use CFLAGS.

Sat Jul 12 11:28:22 MET DST 1997 Zsolt Koppany <zkoppany@multix.de>

	* generic/tkImgGIF.c
	  Patch from tk8.b2 in GetCode().
	* generic/tkImgPhoto.c
	 Purify UMR bug fix in AllocateColors().

Wed Jul  9 14:43:57 1997  Ian Lance Taylor  <ian@cygnus.com>

	* generic/tkMain.c: Include winuser.h if _WIN32.
	(Tk_Main): If _WIN32, call MessageBox on error.

Fri Jul  4 13:36:03 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinImage.c (PutPixel): Correct yet another bug.

Thu Jul  3 16:00:57 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/tkWinImage.c (PutPixel): For a depth of 16 bits, convert a
	24 bit truecolor value into a 16 bit truecolor value.  Correct
	error in storing high byte.  For a depth of 1 bit, correct error
	in clearing bit.

Thu Jun 26 14:02:03 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in (WINDRES): New variable.
	(install-binaries): Don't install DLL here...
	(install-libraries): ...install it here instead.
	($(TKDLL)): Depend upon and link with tkres.o.
	($(WISH)): Depend upon and link with wishres.o.
	($(TKTEST)): Likewise.
	(tkres.o, wishres.o): New targets.
	* win/tkWinX.c (TkWinGetTkModule): If __CYGWIN32__, use cygtkdll
	as the DLL name.
	* win/configure.in: Define and substitute WINDRES.
	* win/configure: Rebuild.

Tue Jun 24 11:42:06 1997  Tom Tromey  <tromey@cygnus.com>

	* library/palette.tcl (tkRecolorTree): Properly quote color name.
	From Jeffrey Hobbs.

Mon Jun 23 10:15:56 1997  Ian Lance Taylor  <ian@cygnus.com>

	* Makefile.in (install-binaries, install-libraries): New targets.

Wed Jun 18 12:21:57 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in: Copy install, install-binaries,
 	install-libraries, and install-demos rules, and associated
 	variables from unix/Makefile.in, with appropriate adjustments.

Thu Jun 12 19:20:57 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/Makefile.in (tkcyg.def): Don't export impure_ptr.

Tue Jun 10 19:16:39 1997  Stephen Peters  <speters@cygnus.com>

	* unix/configure.in: Use a real replacement for memmove, instead
	  of using memcpy (which doesn't guarantee overlaps will copy
	  correctly).  
	* unix/configure: Rebuilt.
	* unix/Makefile.in: Use replacement memmove if needed. 
	* compat/memmove.c: New file for replacing memmove.

Mon Jun  9 16:26:13 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/configure.in: Set TK_BUILD_INCLUDES.
	* win/configure: Rebuild.

Fri Jun  6 23:43:34 1997  Ian Lance Taylor  <ian@cygnus.com>

	Add support for building with cygwin32:
	* win/Makefile.in: Rewrite completely based on makefile.vc.
	* win/configure.in: Rewrite completely.
	* win/configure: Rebuild.
	* win/tkWin32Dll.c (_impure_ptr): Define if __CYGWIN32__.
	(__imp_reent_data): Declare if __CYGWIN32__.
	(DllMain): Initialize _impure_ptr if __CYGWIN32__.
	* win/tkWinX.c (GetCurrentTime): Define as GetTickCount if
	__CYGWIN32__.

Thu May 22 15:49:40 1997  Ian Lance Taylor  <ian@cygnus.com>

	* win/configure.in: Use win rather than CONFIGDIR.
	* win/configure: Rebuild.

Fri May  9 19:07:17 1997  Zsolt Koppany <zkoppany@multix.de>

	* generic/tkWindow.c (GetScreen): Init metaModMask, altModMask
	(from Purify).

Tue May 13 23:19:20 1997  Zsolt Koppany  <zsolt@cygnus.com>

	* generic/tkText.c (ConfigureText): Bug fix from Ousterhout.

Wed Apr 23 14:36:14 1997  Tom Tromey  <tromey@cygnus.com>

	* library/tkfbox.tcl: Incorporated version from Tk 8.0.

Tue Mar 25 23:35:02 1997  Martin M. Hunt  <hunt@cygnus.com>

	* library/palette.tcl: Patch from kcorey@eng.sun.com 
	(Ken Corey) 

Tue Mar 18 16:01:05 1997  Martin M. Hunt  <hunt@cygnus.com>

	* generic/tkImgGIF.c: Fix GIF transparency.  Patch from
	nijtmans@nici.kun.nl

Thu Mar 13 10:42:01 1997  Tom Tromey  <tromey@cygnus.com>

	* win/configure.in: Don't run AC_C_CROSS.
	(AC_CONFIG_AUX_DIR): Look in srcdir.

Fri Mar  7 13:08:47 1997  Tom Tromey  <tromey@cygnus.com>

	* Updated to Tk 4.2p2.

Thu Nov 21 10:07:02 1996  Tom Tromey  <tromey@cygnus.com>

	* generic/tkGrid.c (Tk_GridCmd): Applied fix suggested by Stephen
	Uhler.

	* library/menu.tcl: Applied patch from Ousterhout.

Mon Oct 14 12:17:11 1996  Tom Tromey  <tromey@cygnus.com>

	* Makefile.in (RUNTEST): Use srcdir, not SRC_DIR.
	(tk-check): Ditto.
	(check): Renamed from tk-check.

	* testsuite/config/default.exp (find_x_display): New proc.
	(tk_start): Use find_x_display.

Mon Aug 19 12:30:51 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* testsuite/config/default.exp, testsuite/tk.tests/tk-test.exp:
	New files.

	* Makefile.in (EXPECT, RUNTESTFLAGS, RUNTEST): New variables.
	(tk-check): New target.

	* tests/all: Look for tests in srcdir.
	* tests/defs: Set srcdir if not already set.

Thu Aug 15 12:50:47 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* generic/tkArgv.c (defaultTable): Added -version.
	(Tk_ParseArgv): Handle -version option.
	* generic/tk.h (TK_ARGV_VERSION): New define.

Mon Aug  5 10:47:09 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* Makefile.in (configure): Don't depend on configure.in.
	(config.status): Depend on configure.

Wed Jun 26 12:51:43 1996  Jason Molenda  (crash@godzilla.cygnus.co.jp)

	* configure.in (AC_PREREQ): autoconf 2.5 or higher.
	* configure: Rebuilt.

Mon May  6 09:45:20 1996  Tom Tromey  <tromey@lisa.cygnus.com>

	* generic/tkMain.c (Tk_Main): Exit after printing version number.

Tue Apr 30 13:40:04 1996  Tom Tromey  <tromey@snuffle.cygnus.com>

	* generic/tkMain.c (Tk_Main): Removed "-inet-1.0".

Mon Apr 29 17:43:15 1996  Tom Tromey  <tromey@snuffle.cygnus.com>

	* generic/tkMain.c (argTable): Added -version.
	(Tk_Main): Handle -version.

Thu Mar  7 10:08:57 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* Makefile.in (config.status): Depend on nothing.

Wed Mar  6 19:07:38 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* Makefile.in (Makefile): Removed redundant target.

Thu Feb 29 21:32:44 1996  Fred Fish  <fnf@cygnus.com>

	* Makefile.in (srcdir): Add macro.
	(configure): Run autoconf in source dir, not build dir.

Thu Feb 29 14:59:03 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* Makefile.in (Makefile): New rule.
	(config.status): New rule.

Wed Jan 24 09:42:29 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* Makefile.in: Replaced realclean with maintainer-clean.

Fri Jan 12 11:00:06 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* library/tclIndex: Removed all references to console.tcl.
	(Hack).

	* library/console.tcl (tkConsoleInvoke): Use "interp eval" with
	history command, not nonexistent "interp record" command.
	(tkConsoleHistory, tkConsolePrompt): Include pathname argument to
	"interp eval".

Wed Jan 10 12:49:00 1996  Tom Tromey  <tromey@creche.cygnus.com>

	* configure.in, configure, Makefile.in, README.configure: New
	files.

	* Tk: Updated to Tk4.1a2.  Entries after this line mostly likely
	apply to files in some subdirectory.

Tue Dec 19 18:32:36 1995  Brendan Kehoe  <brendan@lisa.cygnus.com>

	* Makefile.in (check, installcheck): New null rules.

Wed Oct 25 20:12:01 1995  Brendan Kehoe  <brendan@lisa.cygnus.com>

	* Makefile.in (prefix, exec_prefix): Set to @prefix@ and
	@exec_prefix@, so configure can substitute them properly.

Tue Oct 24 18:49:59 1995  Jason Molenda  (crash@phydeaux.cygnus.com)

	* Makefile.in (X11_INCLUDES, X11_LIB_SWITCHES): switch to
	X11_CFLAGS, X11_LDFLAGS and X11_LIBS.
	(CC_SWITCHES): Use X11_CFLAGS.

	* configure.in: Statically link X libraries on Solaris, SunOS,
	and HPUX.

Tue Oct 10 14:33:17 1995  Stu Grossman  (grossman@cygnus.com)

	* tkConfig.c (Tk_ConfigureInfo), tkSelect.c (HandleTclCommand
	LostSelection):  Use free() instead of TCL_DYNAMIC in
	interp->freeProc to prevent crashes.  Apparantly tcl7.4 changed
	the result protocol around slightly.

Sat Sep 30 09:39:11 1995  Jason Molenda  (crash@phydeaux.cygnus.com)

	* configure.in:  Upgraded to autoconf v2, removed cruft which did a poor
        job of finding X location in favor of AC_PATH_X.
	* configure: Regenerated.

Sun Aug 20 00:15:51 1995  Jason Molenda  (crash@phydeaux.cygnus.com)

	* tkMain.c:  make tcl_RcFileName defn an extern so it doesn't
	conflict with the one in the new tcl/tclBasic.c.

Mon Jun 12 17:09:28 1995  Stu Grossman  (grossman@cygnus.com)
	
	* configure:  Ignore --cache-file option instead of bombing out.

Mon Dec 12 12:17:16 1994  Stu Grossman  (grossman@cygnus.com)

	* tkConfig.h:  Don't use prototype for select.  This allows HPUX
	8.x build.

Tue Oct 18 12:41:49 1994  Jim Wilson  (wilson@chestnut.cygnus.com)

	* Makefile.in (CC_SWITCHES): Add X11_INCLUDE_FLAGS.
